#if (__LSB_VERSION__ >= 10 )
#ifndef _GL_GLEXT_H_
#define _GL_GLEXT_H_

#include <GL/gl.h>
#include <stddef.h>

#ifdef __cplusplus
extern "C" {
#endif


#if __LSB_VERSION__ >= 12
#define GLEXT_64_TYPES_DEFINED
#define GL_2X_BIT_ATI	0x00000001
#define GL_RED_BIT_ATI	0x00000001
#define GL_4X_BIT_ATI	0x00000002
#define GL_COMP_BIT_ATI	0x00000002
#define GL_GREEN_BIT_ATI	0x00000002
#define GL_8X_BIT_ATI	0x00000004
#define GL_BLUE_BIT_ATI	0x00000004
#define GL_NEGATE_BIT_ATI	0x00000004
#define GL_VERTEX23_BIT_PGI	0x00000004
#define GL_BIAS_BIT_ATI	0x00000008
#define GL_HALF_BIT_ATI	0x00000008
#define GL_VERTEX4_BIT_PGI	0x00000008
#define GL_QUARTER_BIT_ATI	0x00000010
#define GL_EIGHTH_BIT_ATI	0x00000020
#define GL_SATURATE_BIT_ATI	0x00000040
#define GL_RESTART_SUN	0x0001
#define GL_COLOR3_BIT_PGI	0x00010000
#define GL_REPLACE_MIDDLE_SUN	0x0002
#define GL_COLOR4_BIT_PGI	0x00020000
#define GL_REPLACE_OLDEST_SUN	0x0003
#define GL_EDGEFLAG_BIT_PGI	0x00040000
#define GL_INDEX_BIT_PGI	0x00080000
#define GL_MAT_AMBIENT_BIT_PGI	0x00100000
#define GL_MAT_AMBIENT_AND_DIFFUSE_BIT_PGI	0x00200000
#define GL_MAT_DIFFUSE_BIT_PGI	0x00400000
#define GL_MAT_EMISSION_BIT_PGI	0x00800000
#define GL_MAT_COLOR_INDEXES_BIT_PGI	0x01000000
#define GL_MAT_SHININESS_BIT_PGI	0x02000000
#define GL_MAT_SPECULAR_BIT_PGI	0x04000000
#define GL_INVALID_FRAMEBUFFER_OPERATION_EXT	0x0506
#define GL_NORMAL_BIT_PGI	0x08000000
#define GL_TEXCOORD1_BIT_PGI	0x10000000
#define GL_HALF_FLOAT_ARB	0x140B
#define GL_MODELVIEW0_ARB	0x1700
#define GL_RASTER_POSITION_UNCLIPPED_IBM	0x19262
#define GL_PREFER_DOUBLEBUFFER_HINT_PGI	0x1A1F8
#define GL_CONSERVE_MEMORY_HINT_PGI	0x1A1FD
#define GL_RECLAIM_MEMORY_HINT_PGI	0x1A1FE
#define GL_NATIVE_GRAPHICS_HANDLE_PGI	0x1A202
#define GL_NATIVE_GRAPHICS_BEGIN_HINT_PGI	0x1A203
#define GL_NATIVE_GRAPHICS_END_HINT_PGI	0x1A204
#define GL_ALWAYS_FAST_HINT_PGI	0x1A20C
#define GL_ALWAYS_SOFT_HINT_PGI	0x1A20D
#define GL_ALLOW_DRAW_OBJ_HINT_PGI	0x1A20E
#define GL_ALLOW_DRAW_WIN_HINT_PGI	0x1A20F
#define GL_ALLOW_DRAW_FRG_HINT_PGI	0x1A210
#define GL_ALLOW_DRAW_MEM_HINT_PGI	0x1A211
#define GL_STRICT_DEPTHFUNC_HINT_PGI	0x1A216
#define GL_STRICT_LIGHTING_HINT_PGI	0x1A217
#define GL_STRICT_SCISSOR_HINT_PGI	0x1A218
#define GL_FULL_STIPPLE_HINT_PGI	0x1A219
#define GL_CLIP_NEAR_HINT_PGI	0x1A220
#define GL_CLIP_FAR_HINT_PGI	0x1A221
#define GL_WIDE_LINE_HINT_PGI	0x1A222
#define GL_BACK_NORMALS_HINT_PGI	0x1A223
#define GL_VERTEX_DATA_HINT_PGI	0x1A22A
#define GL_VERTEX_CONSISTENT_HINT_PGI	0x1A22B
#define GL_MATERIAL_SIDE_HINT_PGI	0x1A22C
#define GL_MAX_VERTEX_HINT_PGI	0x1A22D
#define GL_MULTISAMPLE_BIT_3DFX	0x20000000
#define GL_MULTISAMPLE_BIT_ARB	0x20000000
#define GL_MULTISAMPLE_BIT_EXT	0x20000000
#define GL_TEXCOORD2_BIT_PGI	0x20000000
#define GL_TEXCOORD3_BIT_PGI	0x40000000
#define GL_ABGR_EXT	0x8000
#define GL_TEXCOORD4_BIT_PGI	0x80000000
#define GL_CONSTANT_COLOR_EXT	0x8001
#define GL_ONE_MINUS_CONSTANT_COLOR_EXT	0x8002
#define GL_CONSTANT_ALPHA_EXT	0x8003
#define GL_ONE_MINUS_CONSTANT_ALPHA_EXT	0x8004
#define GL_BLEND_COLOR_EXT	0x8005
#define GL_FUNC_ADD_EXT	0x8006
#define GL_MIN_EXT	0x8007
#define GL_MAX_EXT	0x8008
#define GL_BLEND_EQUATION_EXT	0x8009
#define GL_FUNC_SUBTRACT_EXT	0x800A
#define GL_FUNC_REVERSE_SUBTRACT_EXT	0x800B
#define GL_CMYK_EXT	0x800C
#define GL_CMYKA_EXT	0x800D
#define GL_PACK_CMYK_HINT_EXT	0x800E
#define GL_UNPACK_CMYK_HINT_EXT	0x800F
#define GL_CONVOLUTION_1D_EXT	0x8010
#define GL_CONVOLUTION_2D_EXT	0x8011
#define GL_SEPARABLE_2D_EXT	0x8012
#define GL_CONVOLUTION_BORDER_MODE_EXT	0x8013
#define GL_CONVOLUTION_FILTER_SCALE_EXT	0x8014
#define GL_CONVOLUTION_FILTER_BIAS_EXT	0x8015
#define GL_REDUCE_EXT	0x8016
#define GL_CONVOLUTION_FORMAT_EXT	0x8017
#define GL_CONVOLUTION_WIDTH_EXT	0x8018
#define GL_CONVOLUTION_HEIGHT_EXT	0x8019
#define GL_MAX_CONVOLUTION_WIDTH_EXT	0x801A
#define GL_MAX_CONVOLUTION_HEIGHT_EXT	0x801B
#define GL_POST_CONVOLUTION_RED_SCALE_EXT	0x801C
#define GL_POST_CONVOLUTION_GREEN_SCALE_EXT	0x801D
#define GL_POST_CONVOLUTION_BLUE_SCALE_EXT	0x801E
#define GL_POST_CONVOLUTION_ALPHA_SCALE_EXT	0x801F
#define GL_POST_CONVOLUTION_RED_BIAS_EXT	0x8020
#define GL_POST_CONVOLUTION_GREEN_BIAS_EXT	0x8021
#define GL_POST_CONVOLUTION_BLUE_BIAS_EXT	0x8022
#define GL_POST_CONVOLUTION_ALPHA_BIAS_EXT	0x8023
#define GL_HISTOGRAM_EXT	0x8024
#define GL_PROXY_HISTOGRAM_EXT	0x8025
#define GL_HISTOGRAM_WIDTH_EXT	0x8026
#define GL_HISTOGRAM_FORMAT_EXT	0x8027
#define GL_HISTOGRAM_RED_SIZE_EXT	0x8028
#define GL_HISTOGRAM_GREEN_SIZE_EXT	0x8029
#define GL_HISTOGRAM_BLUE_SIZE_EXT	0x802A
#define GL_HISTOGRAM_ALPHA_SIZE_EXT	0x802B
#define GL_HISTOGRAM_LUMINANCE_SIZE_EXT	0x802C
#define GL_HISTOGRAM_SINK_EXT	0x802D
#define GL_MINMAX_EXT	0x802E
#define GL_MINMAX_FORMAT_EXT	0x802F
#define GL_MINMAX_SINK_EXT	0x8030
#define GL_TABLE_TOO_LARGE_EXT	0x8031
#define GL_UNSIGNED_BYTE_3_3_2_EXT	0x8032
#define GL_UNSIGNED_SHORT_4_4_4_4_EXT	0x8033
#define GL_UNSIGNED_SHORT_5_5_5_1_EXT	0x8034
#define GL_UNSIGNED_INT_8_8_8_8_EXT	0x8035
#define GL_UNSIGNED_INT_10_10_10_2_EXT	0x8036
#define GL_POLYGON_OFFSET_EXT	0x8037
#define GL_POLYGON_OFFSET_FACTOR_EXT	0x8038
#define GL_POLYGON_OFFSET_BIAS_EXT	0x8039
#define GL_RESCALE_NORMAL_EXT	0x803A
#define GL_ALPHA4_EXT	0x803B
#define GL_ALPHA8_EXT	0x803C
#define GL_ALPHA12_EXT	0x803D
#define GL_ALPHA16_EXT	0x803E
#define GL_LUMINANCE4_EXT	0x803F
#define GL_LUMINANCE8_EXT	0x8040
#define GL_LUMINANCE12_EXT	0x8041
#define GL_LUMINANCE16_EXT	0x8042
#define GL_LUMINANCE4_ALPHA4_EXT	0x8043
#define GL_LUMINANCE6_ALPHA2_EXT	0x8044
#define GL_LUMINANCE8_ALPHA8_EXT	0x8045
#define GL_LUMINANCE12_ALPHA4_EXT	0x8046
#define GL_LUMINANCE12_ALPHA12_EXT	0x8047
#define GL_LUMINANCE16_ALPHA16_EXT	0x8048
#define GL_INTENSITY_EXT	0x8049
#define GL_INTENSITY4_EXT	0x804A
#define GL_INTENSITY8_EXT	0x804B
#define GL_INTENSITY12_EXT	0x804C
#define GL_INTENSITY16_EXT	0x804D
#define GL_RGB2_EXT	0x804E
#define GL_RGB4_EXT	0x804F
#define GL_RGB5_EXT	0x8050
#define GL_RGB8_EXT	0x8051
#define GL_RGB10_EXT	0x8052
#define GL_RGB12_EXT	0x8053
#define GL_RGB16_EXT	0x8054
#define GL_RGBA2_EXT	0x8055
#define GL_RGBA4_EXT	0x8056
#define GL_RGB5_A1_EXT	0x8057
#define GL_RGBA8_EXT	0x8058
#define GL_RGB10_A2_EXT	0x8059
#define GL_RGBA12_EXT	0x805A
#define GL_RGBA16_EXT	0x805B
#define GL_TEXTURE_RED_SIZE_EXT	0x805C
#define GL_TEXTURE_GREEN_SIZE_EXT	0x805D
#define GL_TEXTURE_BLUE_SIZE_EXT	0x805E
#define GL_TEXTURE_ALPHA_SIZE_EXT	0x805F
#define GL_TEXTURE_LUMINANCE_SIZE_EXT	0x8060
#define GL_TEXTURE_INTENSITY_SIZE_EXT	0x8061
#define GL_REPLACE_EXT	0x8062
#define GL_PROXY_TEXTURE_1D_EXT	0x8063
#define GL_PROXY_TEXTURE_2D_EXT	0x8064
#define GL_TEXTURE_TOO_LARGE_EXT	0x8065
#define GL_TEXTURE_PRIORITY_EXT	0x8066
#define GL_TEXTURE_RESIDENT_EXT	0x8067
#define GL_TEXTURE_1D_BINDING_EXT	0x8068
#define GL_TEXTURE_2D_BINDING_EXT	0x8069
#define GL_TEXTURE_3D_BINDING_EXT	0x806A
#define GL_PACK_SKIP_IMAGES_EXT	0x806B
#define GL_PACK_IMAGE_HEIGHT_EXT	0x806C
#define GL_UNPACK_SKIP_IMAGES_EXT	0x806D
#define GL_UNPACK_IMAGE_HEIGHT_EXT	0x806E
#define GL_TEXTURE_3D_EXT	0x806F
#define GL_PROXY_TEXTURE_3D_EXT	0x8070
#define GL_TEXTURE_DEPTH_EXT	0x8071
#define GL_TEXTURE_WRAP_R_EXT	0x8072
#define GL_MAX_3D_TEXTURE_SIZE_EXT	0x8073
#define GL_VERTEX_ARRAY_EXT	0x8074
#define GL_NORMAL_ARRAY_EXT	0x8075
#define GL_COLOR_ARRAY_EXT	0x8076
#define GL_INDEX_ARRAY_EXT	0x8077
#define GL_TEXTURE_COORD_ARRAY_EXT	0x8078
#define GL_EDGE_FLAG_ARRAY_EXT	0x8079
#define GL_VERTEX_ARRAY_SIZE_EXT	0x807A
#define GL_VERTEX_ARRAY_TYPE_EXT	0x807B
#define GL_VERTEX_ARRAY_STRIDE_EXT	0x807C
#define GL_VERTEX_ARRAY_COUNT_EXT	0x807D
#define GL_NORMAL_ARRAY_TYPE_EXT	0x807E
#define GL_NORMAL_ARRAY_STRIDE_EXT	0x807F
#define GL_NORMAL_ARRAY_COUNT_EXT	0x8080
#define GL_COLOR_ARRAY_SIZE_EXT	0x8081
#define GL_COLOR_ARRAY_TYPE_EXT	0x8082
#define GL_COLOR_ARRAY_STRIDE_EXT	0x8083
#define GL_COLOR_ARRAY_COUNT_EXT	0x8084
#define GL_INDEX_ARRAY_TYPE_EXT	0x8085
#define GL_INDEX_ARRAY_STRIDE_EXT	0x8086
#define GL_INDEX_ARRAY_COUNT_EXT	0x8087
#define GL_TEXTURE_COORD_ARRAY_SIZE_EXT	0x8088
#define GL_TEXTURE_COORD_ARRAY_TYPE_EXT	0x8089
#define GL_TEXTURE_COORD_ARRAY_STRIDE_EXT	0x808A
#define GL_TEXTURE_COORD_ARRAY_COUNT_EXT	0x808B
#define GL_EDGE_FLAG_ARRAY_STRIDE_EXT	0x808C
#define GL_EDGE_FLAG_ARRAY_COUNT_EXT	0x808D
#define GL_VERTEX_ARRAY_POINTER_EXT	0x808E
#define GL_NORMAL_ARRAY_POINTER_EXT	0x808F
#define GL_COLOR_ARRAY_POINTER_EXT	0x8090
#define GL_INDEX_ARRAY_POINTER_EXT	0x8091
#define GL_TEXTURE_COORD_ARRAY_POINTER_EXT	0x8092
#define GL_EDGE_FLAG_ARRAY_POINTER_EXT	0x8093
#define GL_MULTISAMPLE_ARB	0x809D
#define GL_MULTISAMPLE_EXT	0x809D
#define GL_SAMPLE_ALPHA_TO_COVERAGE_ARB	0x809E
#define GL_SAMPLE_ALPHA_TO_MASK_EXT	0x809E
#define GL_SAMPLE_ALPHA_TO_ONE_ARB	0x809F
#define GL_SAMPLE_ALPHA_TO_ONE_EXT	0x809F
#define GL_SAMPLE_COVERAGE_ARB	0x80A0
#define GL_SAMPLE_MASK_EXT	0x80A0
#define GL_1PASS_EXT	0x80A1
#define GL_2PASS_0_EXT	0x80A2
#define GL_2PASS_1_EXT	0x80A3
#define GL_4PASS_0_EXT	0x80A4
#define GL_4PASS_1_EXT	0x80A5
#define GL_4PASS_2_EXT	0x80A6
#define GL_4PASS_3_EXT	0x80A7
#define GL_SAMPLE_BUFFERS_ARB	0x80A8
#define GL_SAMPLE_BUFFERS_EXT	0x80A8
#define GL_SAMPLES_ARB	0x80A9
#define GL_SAMPLES_EXT	0x80A9
#define GL_SAMPLE_COVERAGE_VALUE_ARB	0x80AA
#define GL_SAMPLE_MASK_VALUE_EXT	0x80AA
#define GL_SAMPLE_COVERAGE_INVERT_ARB	0x80AB
#define GL_SAMPLE_MASK_INVERT_EXT	0x80AB
#define GL_SAMPLE_PATTERN_EXT	0x80AC
#define GL_TEXTURE_COMPARE_FAIL_VALUE_ARB	0x80BF
#define GL_BLEND_DST_RGB	0x80C8
#define GL_BLEND_DST_RGB_EXT	0x80C8
#define GL_BLEND_SRC_RGB	0x80C9
#define GL_BLEND_SRC_RGB_EXT	0x80C9
#define GL_BLEND_DST_ALPHA	0x80CA
#define GL_BLEND_DST_ALPHA_EXT	0x80CA
#define GL_BLEND_SRC_ALPHA	0x80CB
#define GL_BLEND_SRC_ALPHA_EXT	0x80CB
#define GL_422_EXT	0x80CC
#define GL_422_REV_EXT	0x80CD
#define GL_422_AVERAGE_EXT	0x80CE
#define GL_422_REV_AVERAGE_EXT	0x80CF
#define GL_BGR_EXT	0x80E0
#define GL_BGRA_EXT	0x80E1
#define GL_COLOR_INDEX1_EXT	0x80E2
#define GL_COLOR_INDEX2_EXT	0x80E3
#define GL_COLOR_INDEX4_EXT	0x80E4
#define GL_COLOR_INDEX8_EXT	0x80E5
#define GL_COLOR_INDEX12_EXT	0x80E6
#define GL_COLOR_INDEX16_EXT	0x80E7
#define GL_MAX_ELEMENTS_VERTICES_EXT	0x80E8
#define GL_MAX_ELEMENTS_INDICES_EXT	0x80E9
#define GL_PHONG_WIN	0x80EA
#define GL_PHONG_HINT_WIN	0x80EB
#define GL_FOG_SPECULAR_TEXTURE_WIN	0x80EC
#define GL_TEXTURE_INDEX_SIZE_EXT	0x80ED
#define GL_CLIP_VOLUME_CLIPPING_HINT_EXT	0x80F0
#define GL_POINT_SIZE_MIN	0x8126
#define GL_POINT_SIZE_MIN_ARB	0x8126
#define GL_POINT_SIZE_MIN_EXT	0x8126
#define GL_POINT_SIZE_MAX	0x8127
#define GL_POINT_SIZE_MAX_ARB	0x8127
#define GL_POINT_SIZE_MAX_EXT	0x8127
#define GL_POINT_FADE_THRESHOLD_SIZE	0x8128
#define GL_POINT_FADE_THRESHOLD_SIZE_ARB	0x8128
#define GL_POINT_FADE_THRESHOLD_SIZE_EXT	0x8128
#define GL_DISTANCE_ATTENUATION_EXT	0x8129
#define GL_POINT_DISTANCE_ATTENUATION	0x8129
#define GL_POINT_DISTANCE_ATTENUATION_ARB	0x8129
#define GL_CLAMP_TO_BORDER_ARB	0x812D
#define GL_IGNORE_BORDER_HP	0x8150
#define GL_CONSTANT_BORDER_HP	0x8151
#define GL_REPLICATE_BORDER_HP	0x8153
#define GL_CONVOLUTION_BORDER_COLOR_HP	0x8154
#define GL_IMAGE_SCALE_X_HP	0x8155
#define GL_IMAGE_SCALE_Y_HP	0x8156
#define GL_IMAGE_TRANSLATE_X_HP	0x8157
#define GL_IMAGE_TRANSLATE_Y_HP	0x8158
#define GL_IMAGE_ROTATE_ANGLE_HP	0x8159
#define GL_IMAGE_ROTATE_ORIGIN_X_HP	0x815A
#define GL_IMAGE_ROTATE_ORIGIN_Y_HP	0x815B
#define GL_IMAGE_MAG_FILTER_HP	0x815C
#define GL_IMAGE_MIN_FILTER_HP	0x815D
#define GL_IMAGE_CUBIC_WEIGHT_HP	0x815E
#define GL_CUBIC_HP	0x815F
#define GL_AVERAGE_HP	0x8160
#define GL_IMAGE_TRANSFORM_2D_HP	0x8161
#define GL_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP	0x8162
#define GL_PROXY_POST_IMAGE_TRANSFORM_COLOR_TABLE_HP	0x8163
#define GL_OCCLUSION_TEST_HP	0x8165
#define GL_OCCLUSION_TEST_RESULT_HP	0x8166
#define GL_TEXTURE_LIGHTING_MODE_HP	0x8167
#define GL_TEXTURE_POST_SPECULAR_HP	0x8168
#define GL_TEXTURE_PRE_SPECULAR_HP	0x8169
#define GL_GENERATE_MIPMAP	0x8191
#define GL_GENERATE_MIPMAP_HINT	0x8192
#define GL_DEPTH_COMPONENT16	0x81A5
#define GL_DEPTH_COMPONENT16_ARB	0x81A5
#define GL_DEPTH_COMPONENT24	0x81A6
#define GL_DEPTH_COMPONENT24_ARB	0x81A6
#define GL_DEPTH_COMPONENT32	0x81A7
#define GL_DEPTH_COMPONENT32_ARB	0x81A7
#define GL_ARRAY_ELEMENT_LOCK_FIRST_EXT	0x81A8
#define GL_ARRAY_ELEMENT_LOCK_COUNT_EXT	0x81A9
#define GL_CULL_VERTEX_EXT	0x81AA
#define GL_CULL_VERTEX_EYE_POSITION_EXT	0x81AB
#define GL_CULL_VERTEX_OBJECT_POSITION_EXT	0x81AC
#define GL_IUI_V2F_EXT	0x81AD
#define GL_IUI_V3F_EXT	0x81AE
#define GL_IUI_N3F_V2F_EXT	0x81AF
#define GL_IUI_N3F_V3F_EXT	0x81B0
#define GL_T2F_IUI_V2F_EXT	0x81B1
#define GL_T2F_IUI_V3F_EXT	0x81B2
#define GL_T2F_IUI_N3F_V2F_EXT	0x81B3
#define GL_T2F_IUI_N3F_V3F_EXT	0x81B4
#define GL_INDEX_TEST_EXT	0x81B5
#define GL_INDEX_TEST_FUNC_EXT	0x81B6
#define GL_INDEX_TEST_REF_EXT	0x81B7
#define GL_INDEX_MATERIAL_EXT	0x81B8
#define GL_INDEX_MATERIAL_PARAMETER_EXT	0x81B9
#define GL_INDEX_MATERIAL_FACE_EXT	0x81BA
#define GL_WRAP_BORDER_SUN	0x81D4
#define GL_UNPACK_CONSTANT_DATA_SUNX	0x81D5
#define GL_TEXTURE_CONSTANT_DATA_SUNX	0x81D6
#define GL_TRIANGLE_LIST_SUN	0x81D7
#define GL_REPLACEMENT_CODE_SUN	0x81D8
#define GL_GLOBAL_ALPHA_SUN	0x81D9
#define GL_GLOBAL_ALPHA_FACTOR_SUN	0x81DA
#define GL_LIGHT_MODEL_COLOR_CONTROL_EXT	0x81F8
#define GL_SINGLE_COLOR_EXT	0x81F9
#define GL_SEPARATE_SPECULAR_COLOR_EXT	0x81FA
#define GL_SHARED_TEXTURE_PALETTE_EXT	0x81FB
#define GL_TEXT_FRAGMENT_SHADER_ATI	0x8200
#define GL_PIXEL_TRANSFORM_2D_EXT	0x8330
#define GL_PIXEL_MAG_FILTER_EXT	0x8331
#define GL_PIXEL_MIN_FILTER_EXT	0x8332
#define GL_PIXEL_CUBIC_WEIGHT_EXT	0x8333
#define GL_CUBIC_EXT	0x8334
#define GL_AVERAGE_EXT	0x8335
#define GL_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT	0x8336
#define GL_MAX_PIXEL_TRANSFORM_2D_STACK_DEPTH_EXT	0x8337
#define GL_PIXEL_TRANSFORM_2D_MATRIX_EXT	0x8338
#define GL_FRAGMENT_MATERIAL_EXT	0x8349
#define GL_FRAGMENT_NORMAL_EXT	0x834A
#define GL_FRAGMENT_COLOR_EXT	0x834C
#define GL_ATTENUATION_EXT	0x834D
#define GL_SHADOW_ATTENUATION_EXT	0x834E
#define GL_TEXTURE_APPLICATION_MODE_EXT	0x834F
#define GL_TEXTURE_LIGHT_EXT	0x8350
#define GL_TEXTURE_MATERIAL_FACE_EXT	0x8351
#define GL_TEXTURE_MATERIAL_PARAMETER_EXT	0x8352
#define GL_MIRRORED_REPEAT	0x8370
#define GL_MIRRORED_REPEAT_ARB	0x8370
#define GL_MIRRORED_REPEAT_IBM	0x8370
#define GL_RGB_S3TC	0x83A0
#define GL_RGB4_S3TC	0x83A1
#define GL_RGBA_S3TC	0x83A2
#define GL_RGBA4_S3TC	0x83A3
#define GL_COMPRESSED_RGB_S3TC_DXT1_EXT	0x83F0
#define GL_COMPRESSED_RGBA_S3TC_DXT1_EXT	0x83F1
#define GL_COMPRESSED_RGBA_S3TC_DXT3_EXT	0x83F2
#define GL_COMPRESSED_RGBA_S3TC_DXT5_EXT	0x83F3
#define GL_PARALLEL_ARRAYS_INTEL	0x83F4
#define GL_VERTEX_ARRAY_PARALLEL_POINTERS_INTEL	0x83F5
#define GL_NORMAL_ARRAY_PARALLEL_POINTERS_INTEL	0x83F6
#define GL_COLOR_ARRAY_PARALLEL_POINTERS_INTEL	0x83F7
#define GL_TEXTURE_COORD_ARRAY_PARALLEL_POINTERS_INTEL	0x83F8
#define GL_TANGENT_ARRAY_EXT	0x8439
#define GL_BINORMAL_ARRAY_EXT	0x843A
#define GL_CURRENT_TANGENT_EXT	0x843B
#define GL_CURRENT_BINORMAL_EXT	0x843C
#define GL_TANGENT_ARRAY_TYPE_EXT	0x843E
#define GL_TANGENT_ARRAY_STRIDE_EXT	0x843F
#define GL_BINORMAL_ARRAY_TYPE_EXT	0x8440
#define GL_BINORMAL_ARRAY_STRIDE_EXT	0x8441
#define GL_TANGENT_ARRAY_POINTER_EXT	0x8442
#define GL_BINORMAL_ARRAY_POINTER_EXT	0x8443
#define GL_MAP1_TANGENT_EXT	0x8444
#define GL_MAP2_TANGENT_EXT	0x8445
#define GL_MAP1_BINORMAL_EXT	0x8446
#define GL_MAP2_BINORMAL_EXT	0x8447
#define GL_FOG_COORDINATE_SOURCE	0x8450
#define GL_FOG_COORDINATE_SOURCE_EXT	0x8450
#define GL_FOG_COORDINATE	0x8451
#define GL_FOG_COORDINATE_EXT	0x8451
#define GL_FRAGMENT_DEPTH	0x8452
#define GL_FRAGMENT_DEPTH_EXT	0x8452
#define GL_CURRENT_FOG_COORDINATE	0x8453
#define GL_CURRENT_FOG_COORDINATE_EXT	0x8453
#define GL_FOG_COORDINATE_ARRAY_TYPE	0x8454
#define GL_FOG_COORDINATE_ARRAY_TYPE_EXT	0x8454
#define GL_FOG_COORDINATE_ARRAY_STRIDE	0x8455
#define GL_FOG_COORDINATE_ARRAY_STRIDE_EXT	0x8455
#define GL_FOG_COORDINATE_ARRAY_POINTER	0x8456
#define GL_FOG_COORDINATE_ARRAY_POINTER_EXT	0x8456
#define GL_FOG_COORDINATE_ARRAY	0x8457
#define GL_FOG_COORDINATE_ARRAY_EXT	0x8457
#define GL_COLOR_SUM	0x8458
#define GL_COLOR_SUM_ARB	0x8458
#define GL_COLOR_SUM_EXT	0x8458
#define GL_CURRENT_SECONDARY_COLOR	0x8459
#define GL_CURRENT_SECONDARY_COLOR_EXT	0x8459
#define GL_SECONDARY_COLOR_ARRAY_SIZE	0x845A
#define GL_SECONDARY_COLOR_ARRAY_SIZE_EXT	0x845A
#define GL_SECONDARY_COLOR_ARRAY_TYPE	0x845B
#define GL_SECONDARY_COLOR_ARRAY_TYPE_EXT	0x845B
#define GL_SECONDARY_COLOR_ARRAY_STRIDE	0x845C
#define GL_SECONDARY_COLOR_ARRAY_STRIDE_EXT	0x845C
#define GL_SECONDARY_COLOR_ARRAY_POINTER	0x845D
#define GL_SECONDARY_COLOR_ARRAY_POINTER_EXT	0x845D
#define GL_SECONDARY_COLOR_ARRAY	0x845E
#define GL_SECONDARY_COLOR_ARRAY_EXT	0x845E
#define GL_SCREEN_COORDINATES_REND	0x8490
#define GL_INVERTED_SCREEN_W_REND	0x8491
#define GL_TRANSPOSE_MODELVIEW_MATRIX_ARB	0x84E3
#define GL_TRANSPOSE_PROJECTION_MATRIX_ARB	0x84E4
#define GL_TRANSPOSE_TEXTURE_MATRIX_ARB	0x84E5
#define GL_TRANSPOSE_COLOR_MATRIX_ARB	0x84E6
#define GL_SUBTRACT_ARB	0x84E7
#define GL_MAX_RENDERBUFFER_SIZE_EXT	0x84E8
#define GL_COMPRESSED_ALPHA_ARB	0x84E9
#define GL_COMPRESSED_LUMINANCE_ARB	0x84EA
#define GL_COMPRESSED_LUMINANCE_ALPHA_ARB	0x84EB
#define GL_COMPRESSED_INTENSITY_ARB	0x84EC
#define GL_COMPRESSED_RGB_ARB	0x84ED
#define GL_COMPRESSED_RGBA_ARB	0x84EE
#define GL_TEXTURE_COMPRESSION_HINT_ARB	0x84EF
#define GL_TEXTURE_RECTANGLE_ARB	0x84F5
#define GL_TEXTURE_BINDING_RECTANGLE_ARB	0x84F6
#define GL_PROXY_TEXTURE_RECTANGLE_ARB	0x84F7
#define GL_MAX_RECTANGLE_TEXTURE_SIZE_ARB	0x84F8
#define GL_MAX_TEXTURE_LOD_BIAS	0x84FD
#define GL_MAX_TEXTURE_LOD_BIAS_EXT	0x84FD
#define GL_TEXTURE_MAX_ANISOTROPY_EXT	0x84FE
#define GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT	0x84FF
#define GL_TEXTURE_FILTER_CONTROL	0x8500
#define GL_TEXTURE_FILTER_CONTROL_EXT	0x8500
#define GL_TEXTURE_LOD_BIAS	0x8501
#define GL_TEXTURE_LOD_BIAS_EXT	0x8501
#define GL_MODELVIEW1_STACK_DEPTH_EXT	0x8502
#define GL_MODELVIEW1_MATRIX_EXT	0x8506
#define GL_INCR_WRAP	0x8507
#define GL_INCR_WRAP_EXT	0x8507
#define GL_DECR_WRAP	0x8508
#define GL_DECR_WRAP_EXT	0x8508
#define GL_VERTEX_WEIGHTING_EXT	0x8509
#define GL_MODELVIEW1_ARB	0x850A
#define GL_MODELVIEW1_EXT	0x850A
#define GL_CURRENT_VERTEX_WEIGHT_EXT	0x850B
#define GL_VERTEX_WEIGHT_ARRAY_EXT	0x850C
#define GL_VERTEX_WEIGHT_ARRAY_SIZE_EXT	0x850D
#define GL_VERTEX_WEIGHT_ARRAY_TYPE_EXT	0x850E
#define GL_VERTEX_WEIGHT_ARRAY_STRIDE_EXT	0x850F
#define GL_VERTEX_WEIGHT_ARRAY_POINTER_EXT	0x8510
#define GL_NORMAL_MAP_ARB	0x8511
#define GL_NORMAL_MAP_EXT	0x8511
#define GL_REFLECTION_MAP_ARB	0x8512
#define GL_REFLECTION_MAP_EXT	0x8512
#define GL_TEXTURE_CUBE_MAP_ARB	0x8513
#define GL_TEXTURE_CUBE_MAP_EXT	0x8513
#define GL_TEXTURE_BINDING_CUBE_MAP_ARB	0x8514
#define GL_TEXTURE_BINDING_CUBE_MAP_EXT	0x8514
#define GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB	0x8515
#define GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT	0x8515
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB	0x8516
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT	0x8516
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB	0x8517
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT	0x8517
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB	0x8518
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT	0x8518
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB	0x8519
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT	0x8519
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB	0x851A
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT	0x851A
#define GL_PROXY_TEXTURE_CUBE_MAP_ARB	0x851B
#define GL_PROXY_TEXTURE_CUBE_MAP_EXT	0x851B
#define GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB	0x851C
#define GL_MAX_CUBE_MAP_TEXTURE_SIZE_EXT	0x851C
#define GL_RED_MIN_CLAMP_INGR	0x8560
#define GL_GREEN_MIN_CLAMP_INGR	0x8561
#define GL_BLUE_MIN_CLAMP_INGR	0x8562
#define GL_ALPHA_MIN_CLAMP_INGR	0x8563
#define GL_RED_MAX_CLAMP_INGR	0x8564
#define GL_GREEN_MAX_CLAMP_INGR	0x8565
#define GL_BLUE_MAX_CLAMP_INGR	0x8566
#define GL_ALPHA_MAX_CLAMP_INGR	0x8567
#define GL_INTERLACE_READ_INGR	0x8568
#define GL_COMBINE_ARB	0x8570
#define GL_COMBINE_EXT	0x8570
#define GL_COMBINE_RGB_ARB	0x8571
#define GL_COMBINE_RGB_EXT	0x8571
#define GL_COMBINE_ALPHA_ARB	0x8572
#define GL_COMBINE_ALPHA_EXT	0x8572
#define GL_RGB_SCALE_ARB	0x8573
#define GL_RGB_SCALE_EXT	0x8573
#define GL_ADD_SIGNED_ARB	0x8574
#define GL_ADD_SIGNED_EXT	0x8574
#define GL_INTERPOLATE_ARB	0x8575
#define GL_INTERPOLATE_EXT	0x8575
#define GL_CONSTANT_ARB	0x8576
#define GL_CONSTANT_EXT	0x8576
#define GL_PRIMARY_COLOR_ARB	0x8577
#define GL_PRIMARY_COLOR_EXT	0x8577
#define GL_PREVIOUS_ARB	0x8578
#define GL_PREVIOUS_EXT	0x8578
#define GL_SOURCE0_RGB_ARB	0x8580
#define GL_SOURCE0_RGB_EXT	0x8580
#define GL_SOURCE1_RGB_ARB	0x8581
#define GL_SOURCE1_RGB_EXT	0x8581
#define GL_SOURCE2_RGB_ARB	0x8582
#define GL_SOURCE2_RGB_EXT	0x8582
#define GL_SOURCE0_ALPHA_ARB	0x8588
#define GL_SOURCE0_ALPHA_EXT	0x8588
#define GL_SOURCE1_ALPHA_ARB	0x8589
#define GL_SOURCE1_ALPHA_EXT	0x8589
#define GL_SOURCE2_ALPHA_ARB	0x858A
#define GL_SOURCE2_ALPHA_EXT	0x858A
#define GL_OPERAND0_RGB_ARB	0x8590
#define GL_OPERAND0_RGB_EXT	0x8590
#define GL_OPERAND1_RGB_ARB	0x8591
#define GL_OPERAND1_RGB_EXT	0x8591
#define GL_OPERAND2_RGB_ARB	0x8592
#define GL_OPERAND2_RGB_EXT	0x8592
#define GL_OPERAND0_ALPHA_ARB	0x8598
#define GL_OPERAND0_ALPHA_EXT	0x8598
#define GL_OPERAND1_ALPHA_ARB	0x8599
#define GL_OPERAND1_ALPHA_EXT	0x8599
#define GL_OPERAND2_ALPHA_ARB	0x859A
#define GL_OPERAND2_ALPHA_EXT	0x859A
#define GL_PERTURB_EXT	0x85AE
#define GL_TEXTURE_NORMAL_EXT	0x85AF
#define GL_REPLACEMENT_CODE_ARRAY_SUN	0x85C0
#define GL_REPLACEMENT_CODE_ARRAY_TYPE_SUN	0x85C1
#define GL_REPLACEMENT_CODE_ARRAY_STRIDE_SUN	0x85C2
#define GL_REPLACEMENT_CODE_ARRAY_POINTER_SUN	0x85C3
#define GL_R1UI_V3F_SUN	0x85C4
#define GL_R1UI_C4UB_V3F_SUN	0x85C5
#define GL_R1UI_C3F_V3F_SUN	0x85C6
#define GL_R1UI_N3F_V3F_SUN	0x85C7
#define GL_R1UI_C4F_N3F_V3F_SUN	0x85C8
#define GL_R1UI_T2F_V3F_SUN	0x85C9
#define GL_R1UI_T2F_N3F_V3F_SUN	0x85CA
#define GL_R1UI_T2F_C4F_N3F_V3F_SUN	0x85CB
#define GL_SLICE_ACCUM_SUN	0x85CC
#define GL_QUAD_MESH_SUN	0x8614
#define GL_TRIANGLE_MESH_SUN	0x8615
#define GL_VERTEX_PROGRAM_ARB	0x8620
#define GL_VERTEX_ATTRIB_ARRAY_ENABLED	0x8622
#define GL_VERTEX_ATTRIB_ARRAY_ENABLED_ARB	0x8622
#define GL_VERTEX_ATTRIB_ARRAY_SIZE	0x8623
#define GL_VERTEX_ATTRIB_ARRAY_SIZE_ARB	0x8623
#define GL_VERTEX_ATTRIB_ARRAY_STRIDE	0x8624
#define GL_VERTEX_ATTRIB_ARRAY_STRIDE_ARB	0x8624
#define GL_VERTEX_ATTRIB_ARRAY_TYPE	0x8625
#define GL_VERTEX_ATTRIB_ARRAY_TYPE_ARB	0x8625
#define GL_CURRENT_VERTEX_ATTRIB	0x8626
#define GL_CURRENT_VERTEX_ATTRIB_ARB	0x8626
#define GL_PROGRAM_LENGTH_ARB	0x8627
#define GL_PROGRAM_STRING_ARB	0x8628
#define GL_MAX_PROGRAM_MATRIX_STACK_DEPTH_ARB	0x862E
#define GL_MAX_PROGRAM_MATRICES_ARB	0x862F
#define GL_CURRENT_MATRIX_STACK_DEPTH_ARB	0x8640
#define GL_CURRENT_MATRIX_ARB	0x8641
#define GL_VERTEX_PROGRAM_POINT_SIZE	0x8642
#define GL_VERTEX_PROGRAM_POINT_SIZE_ARB	0x8642
#define GL_VERTEX_PROGRAM_TWO_SIDE	0x8643
#define GL_VERTEX_PROGRAM_TWO_SIDE_ARB	0x8643
#define GL_VERTEX_ATTRIB_ARRAY_POINTER	0x8645
#define GL_VERTEX_ATTRIB_ARRAY_POINTER_ARB	0x8645
#define GL_PROGRAM_ERROR_POSITION_ARB	0x864B
#define GL_PROGRAM_BINDING_ARB	0x8677
#define GL_TEXTURE_COMPRESSED_IMAGE_SIZE_ARB	0x86A0
#define GL_TEXTURE_COMPRESSED_ARB	0x86A1
#define GL_NUM_COMPRESSED_TEXTURE_FORMATS_ARB	0x86A2
#define GL_COMPRESSED_TEXTURE_FORMATS_ARB	0x86A3
#define GL_MAX_VERTEX_UNITS_ARB	0x86A4
#define GL_ACTIVE_VERTEX_UNITS_ARB	0x86A5
#define GL_WEIGHT_SUM_UNITY_ARB	0x86A6
#define GL_VERTEX_BLEND_ARB	0x86A7
#define GL_CURRENT_WEIGHT_ARB	0x86A8
#define GL_WEIGHT_ARRAY_TYPE_ARB	0x86A9
#define GL_WEIGHT_ARRAY_STRIDE_ARB	0x86AA
#define GL_WEIGHT_ARRAY_SIZE_ARB	0x86AB
#define GL_WEIGHT_ARRAY_POINTER_ARB	0x86AC
#define GL_WEIGHT_ARRAY_ARB	0x86AD
#define GL_DOT3_RGB_ARB	0x86AE
#define GL_DOT3_RGBA_ARB	0x86AF
#define GL_COMPRESSED_RGB_FXT1_3DFX	0x86B0
#define GL_COMPRESSED_RGBA_FXT1_3DFX	0x86B1
#define GL_MULTISAMPLE_3DFX	0x86B2
#define GL_SAMPLE_BUFFERS_3DFX	0x86B3
#define GL_SAMPLES_3DFX	0x86B4
#define GL_MODELVIEW2_ARB	0x8722
#define GL_MODELVIEW3_ARB	0x8723
#define GL_MODELVIEW4_ARB	0x8724
#define GL_MODELVIEW5_ARB	0x8725
#define GL_MODELVIEW6_ARB	0x8726
#define GL_MODELVIEW7_ARB	0x8727
#define GL_MODELVIEW8_ARB	0x8728
#define GL_MODELVIEW9_ARB	0x8729
#define GL_MODELVIEW10_ARB	0x872A
#define GL_MODELVIEW11_ARB	0x872B
#define GL_MODELVIEW12_ARB	0x872C
#define GL_MODELVIEW13_ARB	0x872D
#define GL_MODELVIEW14_ARB	0x872E
#define GL_MODELVIEW15_ARB	0x872F
#define GL_MODELVIEW16_ARB	0x8730
#define GL_MODELVIEW17_ARB	0x8731
#define GL_MODELVIEW18_ARB	0x8732
#define GL_MODELVIEW19_ARB	0x8733
#define GL_MODELVIEW20_ARB	0x8734
#define GL_MODELVIEW21_ARB	0x8735
#define GL_MODELVIEW22_ARB	0x8736
#define GL_MODELVIEW23_ARB	0x8737
#define GL_MODELVIEW24_ARB	0x8738
#define GL_MODELVIEW25_ARB	0x8739
#define GL_MODELVIEW26_ARB	0x873A
#define GL_MODELVIEW27_ARB	0x873B
#define GL_MODELVIEW28_ARB	0x873C
#define GL_MODELVIEW29_ARB	0x873D
#define GL_MODELVIEW30_ARB	0x873E
#define GL_MODELVIEW31_ARB	0x873F
#define GL_DOT3_RGB_EXT	0x8740
#define GL_DOT3_RGBA_EXT	0x8741
#define GL_MIRROR_CLAMP_ATI	0x8742
#define GL_MIRROR_CLAMP_EXT	0x8742
#define GL_MIRROR_CLAMP_TO_EDGE_ATI	0x8743
#define GL_MIRROR_CLAMP_TO_EDGE_EXT	0x8743
#define GL_MODULATE_ADD_ATI	0x8744
#define GL_MODULATE_SIGNED_ADD_ATI	0x8745
#define GL_MODULATE_SUBTRACT_ATI	0x8746
#define GL_STATIC_ATI	0x8760
#define GL_DYNAMIC_ATI	0x8761
#define GL_PRESERVE_ATI	0x8762
#define GL_DISCARD_ATI	0x8763
#define GL_BUFFER_SIZE	0x8764
#define GL_BUFFER_SIZE_ARB	0x8764
#define GL_OBJECT_BUFFER_SIZE_ATI	0x8764
#define GL_BUFFER_USAGE	0x8765
#define GL_BUFFER_USAGE_ARB	0x8765
#define GL_OBJECT_BUFFER_USAGE_ATI	0x8765
#define GL_ARRAY_OBJECT_BUFFER_ATI	0x8766
#define GL_ARRAY_OBJECT_OFFSET_ATI	0x8767
#define GL_ELEMENT_ARRAY_ATI	0x8768
#define GL_ELEMENT_ARRAY_TYPE_ATI	0x8769
#define GL_ELEMENT_ARRAY_POINTER_ATI	0x876A
#define GL_MAX_VERTEX_STREAMS_ATI	0x876B
#define GL_VERTEX_STREAM0_ATI	0x876C
#define GL_VERTEX_STREAM1_ATI	0x876D
#define GL_VERTEX_STREAM2_ATI	0x876E
#define GL_VERTEX_STREAM3_ATI	0x876F
#define GL_VERTEX_STREAM4_ATI	0x8770
#define GL_VERTEX_STREAM5_ATI	0x8771
#define GL_VERTEX_STREAM6_ATI	0x8772
#define GL_VERTEX_STREAM7_ATI	0x8773
#define GL_VERTEX_SOURCE_ATI	0x8774
#define GL_BUMP_ROT_MATRIX_ATI	0x8775
#define GL_BUMP_ROT_MATRIX_SIZE_ATI	0x8776
#define GL_BUMP_NUM_TEX_UNITS_ATI	0x8777
#define GL_BUMP_TEX_UNITS_ATI	0x8778
#define GL_DUDV_ATI	0x8779
#define GL_DU8DV8_ATI	0x877A
#define GL_BUMP_ENVMAP_ATI	0x877B
#define GL_BUMP_TARGET_ATI	0x877C
#define GL_VERTEX_SHADER_EXT	0x8780
#define GL_VERTEX_SHADER_BINDING_EXT	0x8781
#define GL_OP_INDEX_EXT	0x8782
#define GL_OP_NEGATE_EXT	0x8783
#define GL_OP_DOT3_EXT	0x8784
#define GL_OP_DOT4_EXT	0x8785
#define GL_OP_MUL_EXT	0x8786
#define GL_OP_ADD_EXT	0x8787
#define GL_OP_MADD_EXT	0x8788
#define GL_OP_FRAC_EXT	0x8789
#define GL_OP_MAX_EXT	0x878A
#define GL_OP_MIN_EXT	0x878B
#define GL_OP_SET_GE_EXT	0x878C
#define GL_OP_SET_LT_EXT	0x878D
#define GL_OP_CLAMP_EXT	0x878E
#define GL_OP_FLOOR_EXT	0x878F
#define GL_OP_ROUND_EXT	0x8790
#define GL_OP_EXP_BASE_2_EXT	0x8791
#define GL_OP_LOG_BASE_2_EXT	0x8792
#define GL_OP_POWER_EXT	0x8793
#define GL_OP_RECIP_EXT	0x8794
#define GL_OP_RECIP_SQRT_EXT	0x8795
#define GL_OP_SUB_EXT	0x8796
#define GL_OP_CROSS_PRODUCT_EXT	0x8797
#define GL_OP_MULTIPLY_MATRIX_EXT	0x8798
#define GL_OP_MOV_EXT	0x8799
#define GL_OUTPUT_VERTEX_EXT	0x879A
#define GL_OUTPUT_COLOR0_EXT	0x879B
#define GL_OUTPUT_COLOR1_EXT	0x879C
#define GL_OUTPUT_TEXTURE_COORD0_EXT	0x879D
#define GL_OUTPUT_TEXTURE_COORD1_EXT	0x879E
#define GL_OUTPUT_TEXTURE_COORD2_EXT	0x879F
#define GL_OUTPUT_TEXTURE_COORD3_EXT	0x87A0
#define GL_OUTPUT_TEXTURE_COORD4_EXT	0x87A1
#define GL_OUTPUT_TEXTURE_COORD5_EXT	0x87A2
#define GL_OUTPUT_TEXTURE_COORD6_EXT	0x87A3
#define GL_OUTPUT_TEXTURE_COORD7_EXT	0x87A4
#define GL_OUTPUT_TEXTURE_COORD8_EXT	0x87A5
#define GL_OUTPUT_TEXTURE_COORD9_EXT	0x87A6
#define GL_OUTPUT_TEXTURE_COORD10_EXT	0x87A7
#define GL_OUTPUT_TEXTURE_COORD11_EXT	0x87A8
#define GL_OUTPUT_TEXTURE_COORD12_EXT	0x87A9
#define GL_OUTPUT_TEXTURE_COORD13_EXT	0x87AA
#define GL_OUTPUT_TEXTURE_COORD14_EXT	0x87AB
#define GL_OUTPUT_TEXTURE_COORD15_EXT	0x87AC
#define GL_OUTPUT_TEXTURE_COORD16_EXT	0x87AD
#define GL_OUTPUT_TEXTURE_COORD17_EXT	0x87AE
#define GL_OUTPUT_TEXTURE_COORD18_EXT	0x87AF
#define GL_OUTPUT_TEXTURE_COORD19_EXT	0x87B0
#define GL_OUTPUT_TEXTURE_COORD20_EXT	0x87B1
#define GL_OUTPUT_TEXTURE_COORD21_EXT	0x87B2
#define GL_OUTPUT_TEXTURE_COORD22_EXT	0x87B3
#define GL_OUTPUT_TEXTURE_COORD23_EXT	0x87B4
#define GL_OUTPUT_TEXTURE_COORD24_EXT	0x87B5
#define GL_OUTPUT_TEXTURE_COORD25_EXT	0x87B6
#define GL_OUTPUT_TEXTURE_COORD26_EXT	0x87B7
#define GL_OUTPUT_TEXTURE_COORD27_EXT	0x87B8
#define GL_OUTPUT_TEXTURE_COORD28_EXT	0x87B9
#define GL_OUTPUT_TEXTURE_COORD29_EXT	0x87BA
#define GL_OUTPUT_TEXTURE_COORD30_EXT	0x87BB
#define GL_OUTPUT_TEXTURE_COORD31_EXT	0x87BC
#define GL_OUTPUT_FOG_EXT	0x87BD
#define GL_SCALAR_EXT	0x87BE
#define GL_VECTOR_EXT	0x87BF
#define GL_MATRIX_EXT	0x87C0
#define GL_VARIANT_EXT	0x87C1
#define GL_INVARIANT_EXT	0x87C2
#define GL_LOCAL_CONSTANT_EXT	0x87C3
#define GL_LOCAL_EXT	0x87C4
#define GL_MAX_VERTEX_SHADER_INSTRUCTIONS_EXT	0x87C5
#define GL_MAX_VERTEX_SHADER_VARIANTS_EXT	0x87C6
#define GL_MAX_VERTEX_SHADER_INVARIANTS_EXT	0x87C7
#define GL_MAX_VERTEX_SHADER_LOCAL_CONSTANTS_EXT	0x87C8
#define GL_MAX_VERTEX_SHADER_LOCALS_EXT	0x87C9
#define GL_MAX_OPTIMIZED_VERTEX_SHADER_INSTRUCTIONS_EXT	0x87CA
#define GL_MAX_OPTIMIZED_VERTEX_SHADER_VARIANTS_EXT	0x87CB
#define GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCAL_CONSTANTS_EXT	0x87CC
#define GL_MAX_OPTIMIZED_VERTEX_SHADER_INVARIANTS_EXT	0x87CD
#define GL_MAX_OPTIMIZED_VERTEX_SHADER_LOCALS_EXT	0x87CE
#define GL_VERTEX_SHADER_INSTRUCTIONS_EXT	0x87CF
#define GL_VERTEX_SHADER_VARIANTS_EXT	0x87D0
#define GL_VERTEX_SHADER_INVARIANTS_EXT	0x87D1
#define GL_VERTEX_SHADER_LOCAL_CONSTANTS_EXT	0x87D2
#define GL_VERTEX_SHADER_LOCALS_EXT	0x87D3
#define GL_VERTEX_SHADER_OPTIMIZED_EXT	0x87D4
#define GL_X_EXT	0x87D5
#define GL_Y_EXT	0x87D6
#define GL_Z_EXT	0x87D7
#define GL_W_EXT	0x87D8
#define GL_NEGATIVE_X_EXT	0x87D9
#define GL_NEGATIVE_Y_EXT	0x87DA
#define GL_NEGATIVE_Z_EXT	0x87DB
#define GL_NEGATIVE_W_EXT	0x87DC
#define GL_ZERO_EXT	0x87DD
#define GL_ONE_EXT	0x87DE
#define GL_NEGATIVE_ONE_EXT	0x87DF
#define GL_NORMALIZED_RANGE_EXT	0x87E0
#define GL_FULL_RANGE_EXT	0x87E1
#define GL_CURRENT_VERTEX_EXT	0x87E2
#define GL_MVP_MATRIX_EXT	0x87E3
#define GL_VARIANT_VALUE_EXT	0x87E4
#define GL_VARIANT_DATATYPE_EXT	0x87E5
#define GL_VARIANT_ARRAY_STRIDE_EXT	0x87E6
#define GL_VARIANT_ARRAY_TYPE_EXT	0x87E7
#define GL_VARIANT_ARRAY_EXT	0x87E8
#define GL_VARIANT_ARRAY_POINTER_EXT	0x87E9
#define GL_INVARIANT_VALUE_EXT	0x87EA
#define GL_INVARIANT_DATATYPE_EXT	0x87EB
#define GL_LOCAL_CONSTANT_VALUE_EXT	0x87EC
#define GL_LOCAL_CONSTANT_DATATYPE_EXT	0x87ED
#define GL_PN_TRIANGLES_ATI	0x87F0
#define GL_MAX_PN_TRIANGLES_TESSELATION_LEVEL_ATI	0x87F1
#define GL_PN_TRIANGLES_POINT_MODE_ATI	0x87F2
#define GL_PN_TRIANGLES_NORMAL_MODE_ATI	0x87F3
#define GL_PN_TRIANGLES_TESSELATION_LEVEL_ATI	0x87F4
#define GL_PN_TRIANGLES_POINT_MODE_LINEAR_ATI	0x87F5
#define GL_PN_TRIANGLES_POINT_MODE_CUBIC_ATI	0x87F6
#define GL_PN_TRIANGLES_NORMAL_MODE_LINEAR_ATI	0x87F7
#define GL_PN_TRIANGLES_NORMAL_MODE_QUADRATIC_ATI	0x87F8
#define GL_STENCIL_BACK_FUNC	0x8800
#define GL_STENCIL_BACK_FUNC_ATI	0x8800
#define GL_STENCIL_BACK_FAIL	0x8801
#define GL_STENCIL_BACK_FAIL_ATI	0x8801
#define GL_STENCIL_BACK_PASS_DEPTH_FAIL	0x8802
#define GL_STENCIL_BACK_PASS_DEPTH_FAIL_ATI	0x8802
#define GL_STENCIL_BACK_PASS_DEPTH_PASS	0x8803
#define GL_STENCIL_BACK_PASS_DEPTH_PASS_ATI	0x8803
#define GL_FRAGMENT_PROGRAM_ARB	0x8804
#define GL_PROGRAM_ALU_INSTRUCTIONS_ARB	0x8805
#define GL_PROGRAM_TEX_INSTRUCTIONS_ARB	0x8806
#define GL_PROGRAM_TEX_INDIRECTIONS_ARB	0x8807
#define GL_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB	0x8808
#define GL_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB	0x8809
#define GL_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB	0x880A
#define GL_MAX_PROGRAM_ALU_INSTRUCTIONS_ARB	0x880B
#define GL_MAX_PROGRAM_TEX_INSTRUCTIONS_ARB	0x880C
#define GL_MAX_PROGRAM_TEX_INDIRECTIONS_ARB	0x880D
#define GL_MAX_PROGRAM_NATIVE_ALU_INSTRUCTIONS_ARB	0x880E
#define GL_MAX_PROGRAM_NATIVE_TEX_INSTRUCTIONS_ARB	0x880F
#define GL_MAX_PROGRAM_NATIVE_TEX_INDIRECTIONS_ARB	0x8810
#define GL_RGBA32F_ARB	0x8814
#define GL_RGBA_FLOAT32_ATI	0x8814
#define GL_RGB32F_ARB	0x8815
#define GL_RGB_FLOAT32_ATI	0x8815
#define GL_ALPHA32F_ARB	0x8816
#define GL_ALPHA_FLOAT32_ATI	0x8816
#define GL_INTENSITY32F_ARB	0x8817
#define GL_INTENSITY_FLOAT32_ATI	0x8817
#define GL_LUMINANCE32F_ARB	0x8818
#define GL_LUMINANCE_FLOAT32_ATI	0x8818
#define GL_LUMINANCE_ALPHA32F_ARB	0x8819
#define GL_LUMINANCE_ALPHA_FLOAT32_ATI	0x8819
#define GL_RGBA16F_ARB	0x881A
#define GL_RGBA_FLOAT16_ATI	0x881A
#define GL_RGB16F_ARB	0x881B
#define GL_RGB_FLOAT16_ATI	0x881B
#define GL_ALPHA16F_ARB	0x881C
#define GL_ALPHA_FLOAT16_ATI	0x881C
#define GL_INTENSITY16F_ARB	0x881D
#define GL_INTENSITY_FLOAT16_ATI	0x881D
#define GL_LUMINANCE16F_ARB	0x881E
#define GL_LUMINANCE_FLOAT16_ATI	0x881E
#define GL_LUMINANCE_ALPHA16F_ARB	0x881F
#define GL_LUMINANCE_ALPHA_FLOAT16_ATI	0x881F
#define GL_RGBA_FLOAT_MODE_ARB	0x8820
#define GL_TYPE_RGBA_FLOAT_ATI	0x8820
#define GL_MAX_DRAW_BUFFERS	0x8824
#define GL_MAX_DRAW_BUFFERS_ARB	0x8824
#define GL_MAX_DRAW_BUFFERS_ATI	0x8824
#define GL_DRAW_BUFFER0	0x8825
#define GL_DRAW_BUFFER0_ARB	0x8825
#define GL_DRAW_BUFFER0_ATI	0x8825
#define GL_DRAW_BUFFER1	0x8826
#define GL_DRAW_BUFFER1_ARB	0x8826
#define GL_DRAW_BUFFER1_ATI	0x8826
#define GL_DRAW_BUFFER2	0x8827
#define GL_DRAW_BUFFER2_ARB	0x8827
#define GL_DRAW_BUFFER2_ATI	0x8827
#define GL_DRAW_BUFFER3	0x8828
#define GL_DRAW_BUFFER3_ARB	0x8828
#define GL_DRAW_BUFFER3_ATI	0x8828
#define GL_DRAW_BUFFER4	0x8829
#define GL_DRAW_BUFFER4_ARB	0x8829
#define GL_DRAW_BUFFER4_ATI	0x8829
#define GL_DRAW_BUFFER5	0x882A
#define GL_DRAW_BUFFER5_ARB	0x882A
#define GL_DRAW_BUFFER5_ATI	0x882A
#define GL_DRAW_BUFFER6	0x882B
#define GL_DRAW_BUFFER6_ARB	0x882B
#define GL_DRAW_BUFFER6_ATI	0x882B
#define GL_DRAW_BUFFER7	0x882C
#define GL_DRAW_BUFFER7_ARB	0x882C
#define GL_DRAW_BUFFER7_ATI	0x882C
#define GL_DRAW_BUFFER8	0x882D
#define GL_DRAW_BUFFER8_ARB	0x882D
#define GL_DRAW_BUFFER8_ATI	0x882D
#define GL_DRAW_BUFFER9	0x882E
#define GL_DRAW_BUFFER9_ARB	0x882E
#define GL_DRAW_BUFFER9_ATI	0x882E
#define GL_DRAW_BUFFER10	0x882F
#define GL_DRAW_BUFFER10_ARB	0x882F
#define GL_DRAW_BUFFER10_ATI	0x882F
#define GL_DRAW_BUFFER11	0x8830
#define GL_DRAW_BUFFER11_ARB	0x8830
#define GL_DRAW_BUFFER11_ATI	0x8830
#define GL_DRAW_BUFFER12	0x8831
#define GL_DRAW_BUFFER12_ARB	0x8831
#define GL_DRAW_BUFFER12_ATI	0x8831
#define GL_DRAW_BUFFER13	0x8832
#define GL_DRAW_BUFFER13_ARB	0x8832
#define GL_DRAW_BUFFER13_ATI	0x8832
#define GL_DRAW_BUFFER14	0x8833
#define GL_DRAW_BUFFER14_ARB	0x8833
#define GL_DRAW_BUFFER14_ATI	0x8833
#define GL_DRAW_BUFFER15	0x8834
#define GL_DRAW_BUFFER15_ARB	0x8834
#define GL_DRAW_BUFFER15_ATI	0x8834
#define GL_COLOR_CLEAR_UNCLAMPED_VALUE_ATI	0x8835
#define GL_BLEND_EQUATION_ALPHA	0x883D
#define GL_BLEND_EQUATION_ALPHA_EXT	0x883D
#define GL_MATRIX_PALETTE_ARB	0x8840
#define GL_MAX_MATRIX_PALETTE_STACK_DEPTH_ARB	0x8841
#define GL_MAX_PALETTE_MATRICES_ARB	0x8842
#define GL_CURRENT_PALETTE_MATRIX_ARB	0x8843
#define GL_MATRIX_INDEX_ARRAY_ARB	0x8844
#define GL_CURRENT_MATRIX_INDEX_ARB	0x8845
#define GL_MATRIX_INDEX_ARRAY_SIZE_ARB	0x8846
#define GL_MATRIX_INDEX_ARRAY_TYPE_ARB	0x8847
#define GL_MATRIX_INDEX_ARRAY_STRIDE_ARB	0x8848
#define GL_MATRIX_INDEX_ARRAY_POINTER_ARB	0x8849
#define GL_TEXTURE_DEPTH_SIZE	0x884A
#define GL_TEXTURE_DEPTH_SIZE_ARB	0x884A
#define GL_DEPTH_TEXTURE_MODE	0x884B
#define GL_DEPTH_TEXTURE_MODE_ARB	0x884B
#define GL_TEXTURE_COMPARE_MODE	0x884C
#define GL_TEXTURE_COMPARE_MODE_ARB	0x884C
#define GL_TEXTURE_COMPARE_FUNC	0x884D
#define GL_TEXTURE_COMPARE_FUNC_ARB	0x884D
#define GL_COMPARE_R_TO_TEXTURE	0x884E
#define GL_COMPARE_R_TO_TEXTURE_ARB	0x884E
#define GL_POINT_SPRITE	0x8861
#define GL_POINT_SPRITE_ARB	0x8861
#define GL_COORD_REPLACE	0x8862
#define GL_COORD_REPLACE_ARB	0x8862
#define GL_QUERY_COUNTER_BITS	0x8864
#define GL_QUERY_COUNTER_BITS_ARB	0x8864
#define GL_CURRENT_QUERY	0x8865
#define GL_CURRENT_QUERY_ARB	0x8865
#define GL_QUERY_RESULT	0x8866
#define GL_QUERY_RESULT_ARB	0x8866
#define GL_QUERY_RESULT_AVAILABLE	0x8867
#define GL_QUERY_RESULT_AVAILABLE_ARB	0x8867
#define GL_MAX_VERTEX_ATTRIBS	0x8869
#define GL_MAX_VERTEX_ATTRIBS_ARB	0x8869
#define GL_VERTEX_ATTRIB_ARRAY_NORMALIZED	0x886A
#define GL_VERTEX_ATTRIB_ARRAY_NORMALIZED_ARB	0x886A
#define GL_MAX_TEXTURE_COORDS	0x8871
#define GL_MAX_TEXTURE_COORDS_ARB	0x8871
#define GL_MAX_TEXTURE_IMAGE_UNITS	0x8872
#define GL_MAX_TEXTURE_IMAGE_UNITS_ARB	0x8872
#define GL_PROGRAM_ERROR_STRING_ARB	0x8874
#define GL_PROGRAM_FORMAT_ASCII_ARB	0x8875
#define GL_PROGRAM_FORMAT_ARB	0x8876
#define GL_DEPTH_BOUNDS_TEST_EXT	0x8890
#define GL_DEPTH_BOUNDS_EXT	0x8891
#define GL_ARRAY_BUFFER	0x8892
#define GL_ARRAY_BUFFER_ARB	0x8892
#define GL_ELEMENT_ARRAY_BUFFER	0x8893
#define GL_ELEMENT_ARRAY_BUFFER_ARB	0x8893
#define GL_ARRAY_BUFFER_BINDING	0x8894
#define GL_ARRAY_BUFFER_BINDING_ARB	0x8894
#define GL_ELEMENT_ARRAY_BUFFER_BINDING	0x8895
#define GL_ELEMENT_ARRAY_BUFFER_BINDING_ARB	0x8895
#define GL_VERTEX_ARRAY_BUFFER_BINDING	0x8896
#define GL_VERTEX_ARRAY_BUFFER_BINDING_ARB	0x8896
#define GL_NORMAL_ARRAY_BUFFER_BINDING	0x8897
#define GL_NORMAL_ARRAY_BUFFER_BINDING_ARB	0x8897
#define GL_COLOR_ARRAY_BUFFER_BINDING	0x8898
#define GL_COLOR_ARRAY_BUFFER_BINDING_ARB	0x8898
#define GL_INDEX_ARRAY_BUFFER_BINDING	0x8899
#define GL_INDEX_ARRAY_BUFFER_BINDING_ARB	0x8899
#define GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING	0x889A
#define GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING_ARB	0x889A
#define GL_EDGE_FLAG_ARRAY_BUFFER_BINDING	0x889B
#define GL_EDGE_FLAG_ARRAY_BUFFER_BINDING_ARB	0x889B
#define GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING	0x889C
#define GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING_ARB	0x889C
#define GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING	0x889D
#define GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING_ARB	0x889D
#define GL_WEIGHT_ARRAY_BUFFER_BINDING	0x889E
#define GL_WEIGHT_ARRAY_BUFFER_BINDING_ARB	0x889E
#define GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING	0x889F
#define GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING_ARB	0x889F
#define GL_PROGRAM_INSTRUCTIONS_ARB	0x88A0
#define GL_MAX_PROGRAM_INSTRUCTIONS_ARB	0x88A1
#define GL_PROGRAM_NATIVE_INSTRUCTIONS_ARB	0x88A2
#define GL_MAX_PROGRAM_NATIVE_INSTRUCTIONS_ARB	0x88A3
#define GL_PROGRAM_TEMPORARIES_ARB	0x88A4
#define GL_MAX_PROGRAM_TEMPORARIES_ARB	0x88A5
#define GL_PROGRAM_NATIVE_TEMPORARIES_ARB	0x88A6
#define GL_MAX_PROGRAM_NATIVE_TEMPORARIES_ARB	0x88A7
#define GL_PROGRAM_PARAMETERS_ARB	0x88A8
#define GL_MAX_PROGRAM_PARAMETERS_ARB	0x88A9
#define GL_PROGRAM_NATIVE_PARAMETERS_ARB	0x88AA
#define GL_MAX_PROGRAM_NATIVE_PARAMETERS_ARB	0x88AB
#define GL_PROGRAM_ATTRIBS_ARB	0x88AC
#define GL_MAX_PROGRAM_ATTRIBS_ARB	0x88AD
#define GL_PROGRAM_NATIVE_ATTRIBS_ARB	0x88AE
#define GL_MAX_PROGRAM_NATIVE_ATTRIBS_ARB	0x88AF
#define GL_PROGRAM_ADDRESS_REGISTERS_ARB	0x88B0
#define GL_MAX_PROGRAM_ADDRESS_REGISTERS_ARB	0x88B1
#define GL_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB	0x88B2
#define GL_MAX_PROGRAM_NATIVE_ADDRESS_REGISTERS_ARB	0x88B3
#define GL_MAX_PROGRAM_LOCAL_PARAMETERS_ARB	0x88B4
#define GL_MAX_PROGRAM_ENV_PARAMETERS_ARB	0x88B5
#define GL_PROGRAM_UNDER_NATIVE_LIMITS_ARB	0x88B6
#define GL_TRANSPOSE_CURRENT_MATRIX_ARB	0x88B7
#define GL_READ_ONLY	0x88B8
#define GL_READ_ONLY_ARB	0x88B8
#define GL_WRITE_ONLY	0x88B9
#define GL_WRITE_ONLY_ARB	0x88B9
#define GL_READ_WRITE	0x88BA
#define GL_READ_WRITE_ARB	0x88BA
#define GL_BUFFER_ACCESS	0x88BB
#define GL_BUFFER_ACCESS_ARB	0x88BB
#define GL_BUFFER_MAPPED	0x88BC
#define GL_BUFFER_MAPPED_ARB	0x88BC
#define GL_BUFFER_MAP_POINTER	0x88BD
#define GL_BUFFER_MAP_POINTER_ARB	0x88BD
#define GL_MATRIX0_ARB	0x88C0
#define GL_MATRIX1_ARB	0x88C1
#define GL_MATRIX2_ARB	0x88C2
#define GL_MATRIX3_ARB	0x88C3
#define GL_MATRIX4_ARB	0x88C4
#define GL_MATRIX5_ARB	0x88C5
#define GL_MATRIX6_ARB	0x88C6
#define GL_MATRIX7_ARB	0x88C7
#define GL_MATRIX8_ARB	0x88C8
#define GL_MATRIX9_ARB	0x88C9
#define GL_MATRIX10_ARB	0x88CA
#define GL_MATRIX11_ARB	0x88CB
#define GL_MATRIX12_ARB	0x88CC
#define GL_MATRIX13_ARB	0x88CD
#define GL_MATRIX14_ARB	0x88CE
#define GL_MATRIX15_ARB	0x88CF
#define GL_MATRIX16_ARB	0x88D0
#define GL_MATRIX17_ARB	0x88D1
#define GL_MATRIX18_ARB	0x88D2
#define GL_MATRIX19_ARB	0x88D3
#define GL_MATRIX20_ARB	0x88D4
#define GL_MATRIX21_ARB	0x88D5
#define GL_MATRIX22_ARB	0x88D6
#define GL_MATRIX23_ARB	0x88D7
#define GL_MATRIX24_ARB	0x88D8
#define GL_MATRIX25_ARB	0x88D9
#define GL_MATRIX26_ARB	0x88DA
#define GL_MATRIX27_ARB	0x88DB
#define GL_MATRIX28_ARB	0x88DC
#define GL_MATRIX29_ARB	0x88DD
#define GL_MATRIX30_ARB	0x88DE
#define GL_MATRIX31_ARB	0x88DF
#define GL_STREAM_DRAW	0x88E0
#define GL_STREAM_DRAW_ARB	0x88E0
#define GL_STREAM_READ	0x88E1
#define GL_STREAM_READ_ARB	0x88E1
#define GL_STREAM_COPY	0x88E2
#define GL_STREAM_COPY_ARB	0x88E2
#define GL_STATIC_DRAW	0x88E4
#define GL_STATIC_DRAW_ARB	0x88E4
#define GL_STATIC_READ	0x88E5
#define GL_STATIC_READ_ARB	0x88E5
#define GL_STATIC_COPY	0x88E6
#define GL_STATIC_COPY_ARB	0x88E6
#define GL_DYNAMIC_DRAW	0x88E8
#define GL_DYNAMIC_DRAW_ARB	0x88E8
#define GL_DYNAMIC_READ	0x88E9
#define GL_DYNAMIC_READ_ARB	0x88E9
#define GL_DYNAMIC_COPY	0x88EA
#define GL_DYNAMIC_COPY_ARB	0x88EA
#define GL_PIXEL_PACK_BUFFER_ARB	0x88EB
#define GL_PIXEL_PACK_BUFFER_EXT	0x88EB
#define GL_PIXEL_UNPACK_BUFFER_ARB	0x88EC
#define GL_PIXEL_UNPACK_BUFFER_EXT	0x88EC
#define GL_PIXEL_PACK_BUFFER_BINDING_ARB	0x88ED
#define GL_PIXEL_PACK_BUFFER_BINDING_EXT	0x88ED
#define GL_PIXEL_UNPACK_BUFFER_BINDING_ARB	0x88EF
#define GL_PIXEL_UNPACK_BUFFER_BINDING_EXT	0x88EF
#define GL_STENCIL_TEST_TWO_SIDE_EXT	0x8910
#define GL_ACTIVE_STENCIL_FACE_EXT	0x8911
#define GL_MIRROR_CLAMP_TO_BORDER_EXT	0x8912
#define GL_SAMPLES_PASSED	0x8914
#define GL_SAMPLES_PASSED_ARB	0x8914
#define GL_CLAMP_VERTEX_COLOR_ARB	0x891A
#define GL_CLAMP_FRAGMENT_COLOR_ARB	0x891B
#define GL_CLAMP_READ_COLOR_ARB	0x891C
#define GL_FIXED_ONLY_ARB	0x891D
#define GL_FRAGMENT_SHADER_ATI	0x8920
#define GL_REG_0_ATI	0x8921
#define GL_REG_1_ATI	0x8922
#define GL_REG_2_ATI	0x8923
#define GL_REG_3_ATI	0x8924
#define GL_REG_4_ATI	0x8925
#define GL_REG_5_ATI	0x8926
#define GL_REG_6_ATI	0x8927
#define GL_REG_7_ATI	0x8928
#define GL_REG_8_ATI	0x8929
#define GL_REG_9_ATI	0x892A
#define GL_REG_10_ATI	0x892B
#define GL_REG_11_ATI	0x892C
#define GL_REG_12_ATI	0x892D
#define GL_REG_13_ATI	0x892E
#define GL_REG_14_ATI	0x892F
#define GL_REG_15_ATI	0x8930
#define GL_REG_16_ATI	0x8931
#define GL_REG_17_ATI	0x8932
#define GL_REG_18_ATI	0x8933
#define GL_REG_19_ATI	0x8934
#define GL_REG_20_ATI	0x8935
#define GL_REG_21_ATI	0x8936
#define GL_REG_22_ATI	0x8937
#define GL_REG_23_ATI	0x8938
#define GL_REG_24_ATI	0x8939
#define GL_REG_25_ATI	0x893A
#define GL_REG_26_ATI	0x893B
#define GL_REG_27_ATI	0x893C
#define GL_REG_28_ATI	0x893D
#define GL_REG_29_ATI	0x893E
#define GL_REG_30_ATI	0x893F
#define GL_REG_31_ATI	0x8940
#define GL_CON_0_ATI	0x8941
#define GL_CON_1_ATI	0x8942
#define GL_CON_2_ATI	0x8943
#define GL_CON_3_ATI	0x8944
#define GL_CON_4_ATI	0x8945
#define GL_CON_5_ATI	0x8946
#define GL_CON_6_ATI	0x8947
#define GL_CON_7_ATI	0x8948
#define GL_CON_8_ATI	0x8949
#define GL_CON_9_ATI	0x894A
#define GL_CON_10_ATI	0x894B
#define GL_CON_11_ATI	0x894C
#define GL_CON_12_ATI	0x894D
#define GL_CON_13_ATI	0x894E
#define GL_CON_14_ATI	0x894F
#define GL_CON_15_ATI	0x8950
#define GL_CON_16_ATI	0x8951
#define GL_CON_17_ATI	0x8952
#define GL_CON_18_ATI	0x8953
#define GL_CON_19_ATI	0x8954
#define GL_CON_20_ATI	0x8955
#define GL_CON_21_ATI	0x8956
#define GL_CON_22_ATI	0x8957
#define GL_CON_23_ATI	0x8958
#define GL_CON_24_ATI	0x8959
#define GL_CON_25_ATI	0x895A
#define GL_CON_26_ATI	0x895B
#define GL_CON_27_ATI	0x895C
#define GL_CON_28_ATI	0x895D
#define GL_CON_29_ATI	0x895E
#define GL_CON_30_ATI	0x895F
#define GL_CON_31_ATI	0x8960
#define GL_MOV_ATI	0x8961
#define GL_ADD_ATI	0x8963
#define GL_MUL_ATI	0x8964
#define GL_SUB_ATI	0x8965
#define GL_DOT3_ATI	0x8966
#define GL_DOT4_ATI	0x8967
#define GL_MAD_ATI	0x8968
#define GL_LERP_ATI	0x8969
#define GL_CND_ATI	0x896A
#define GL_CND0_ATI	0x896B
#define GL_DOT2_ADD_ATI	0x896C
#define GL_SECONDARY_INTERPOLATOR_ATI	0x896D
#define GL_NUM_FRAGMENT_REGISTERS_ATI	0x896E
#define GL_NUM_FRAGMENT_CONSTANTS_ATI	0x896F
#define GL_NUM_PASSES_ATI	0x8970
#define GL_NUM_INSTRUCTIONS_PER_PASS_ATI	0x8971
#define GL_NUM_INSTRUCTIONS_TOTAL_ATI	0x8972
#define GL_NUM_INPUT_INTERPOLATOR_COMPONENTS_ATI	0x8973
#define GL_NUM_LOOPBACK_COMPONENTS_ATI	0x8974
#define GL_COLOR_ALPHA_PAIRING_ATI	0x8975
#define GL_SWIZZLE_STR_ATI	0x8976
#define GL_SWIZZLE_STQ_ATI	0x8977
#define GL_SWIZZLE_STR_DR_ATI	0x8978
#define GL_SWIZZLE_STQ_DQ_ATI	0x8979
#define GL_SWIZZLE_STRQ_ATI	0x897A
#define GL_SWIZZLE_STRQ_DQ_ATI	0x897B
#define GL_FRAGMENT_SHADER	0x8B30
#define GL_FRAGMENT_SHADER_ARB	0x8B30
#define GL_VERTEX_SHADER	0x8B31
#define GL_VERTEX_SHADER_ARB	0x8B31
#define GL_PROGRAM_OBJECT_ARB	0x8B40
#define GL_SHADER_OBJECT_ARB	0x8B48
#define GL_MAX_FRAGMENT_UNIFORM_COMPONENTS	0x8B49
#define GL_MAX_FRAGMENT_UNIFORM_COMPONENTS_ARB	0x8B49
#define GL_MAX_VERTEX_UNIFORM_COMPONENTS	0x8B4A
#define GL_MAX_VERTEX_UNIFORM_COMPONENTS_ARB	0x8B4A
#define GL_MAX_VARYING_FLOATS	0x8B4B
#define GL_MAX_VARYING_FLOATS_ARB	0x8B4B
#define GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS	0x8B4C
#define GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS_ARB	0x8B4C
#define GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS	0x8B4D
#define GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS_ARB	0x8B4D
#define GL_OBJECT_TYPE_ARB	0x8B4E
#define GL_OBJECT_SUBTYPE_ARB	0x8B4F
#define GL_SHADER_TYPE	0x8B4F
#define GL_FLOAT_VEC2	0x8B50
#define GL_FLOAT_VEC2_ARB	0x8B50
#define GL_FLOAT_VEC3	0x8B51
#define GL_FLOAT_VEC3_ARB	0x8B51
#define GL_FLOAT_VEC4	0x8B52
#define GL_FLOAT_VEC4_ARB	0x8B52
#define GL_INT_VEC2	0x8B53
#define GL_INT_VEC2_ARB	0x8B53
#define GL_INT_VEC3	0x8B54
#define GL_INT_VEC3_ARB	0x8B54
#define GL_INT_VEC4	0x8B55
#define GL_INT_VEC4_ARB	0x8B55
#define GL_BOOL	0x8B56
#define GL_BOOL_ARB	0x8B56
#define GL_BOOL_VEC2	0x8B57
#define GL_BOOL_VEC2_ARB	0x8B57
#define GL_BOOL_VEC3	0x8B58
#define GL_BOOL_VEC3_ARB	0x8B58
#define GL_BOOL_VEC4	0x8B59
#define GL_BOOL_VEC4_ARB	0x8B59
#define GL_FLOAT_MAT2	0x8B5A
#define GL_FLOAT_MAT2_ARB	0x8B5A
#define GL_FLOAT_MAT3	0x8B5B
#define GL_FLOAT_MAT3_ARB	0x8B5B
#define GL_FLOAT_MAT4	0x8B5C
#define GL_FLOAT_MAT4_ARB	0x8B5C
#define GL_SAMPLER_1D	0x8B5D
#define GL_SAMPLER_1D_ARB	0x8B5D
#define GL_SAMPLER_2D	0x8B5E
#define GL_SAMPLER_2D_ARB	0x8B5E
#define GL_SAMPLER_3D	0x8B5F
#define GL_SAMPLER_3D_ARB	0x8B5F
#define GL_SAMPLER_CUBE	0x8B60
#define GL_SAMPLER_CUBE_ARB	0x8B60
#define GL_SAMPLER_1D_SHADOW	0x8B61
#define GL_SAMPLER_1D_SHADOW_ARB	0x8B61
#define GL_SAMPLER_2D_SHADOW	0x8B62
#define GL_SAMPLER_2D_SHADOW_ARB	0x8B62
#define GL_SAMPLER_2D_RECT_ARB	0x8B63
#define GL_SAMPLER_2D_RECT_SHADOW_ARB	0x8B64
#define GL_DELETE_STATUS	0x8B80
#define GL_OBJECT_DELETE_STATUS_ARB	0x8B80
#define GL_COMPILE_STATUS	0x8B81
#define GL_OBJECT_COMPILE_STATUS_ARB	0x8B81
#define GL_LINK_STATUS	0x8B82
#define GL_OBJECT_LINK_STATUS_ARB	0x8B82
#define GL_OBJECT_VALIDATE_STATUS_ARB	0x8B83
#define GL_VALIDATE_STATUS	0x8B83
#define GL_INFO_LOG_LENGTH	0x8B84
#define GL_OBJECT_INFO_LOG_LENGTH_ARB	0x8B84
#define GL_ATTACHED_SHADERS	0x8B85
#define GL_OBJECT_ATTACHED_OBJECTS_ARB	0x8B85
#define GL_ACTIVE_UNIFORMS	0x8B86
#define GL_OBJECT_ACTIVE_UNIFORMS_ARB	0x8B86
#define GL_ACTIVE_UNIFORM_MAX_LENGTH	0x8B87
#define GL_OBJECT_ACTIVE_UNIFORM_MAX_LENGTH_ARB	0x8B87
#define GL_OBJECT_SHADER_SOURCE_LENGTH_ARB	0x8B88
#define GL_SHADER_SOURCE_LENGTH	0x8B88
#define GL_ACTIVE_ATTRIBUTES	0x8B89
#define GL_OBJECT_ACTIVE_ATTRIBUTES_ARB	0x8B89
#define GL_ACTIVE_ATTRIBUTE_MAX_LENGTH	0x8B8A
#define GL_OBJECT_ACTIVE_ATTRIBUTE_MAX_LENGTH_ARB	0x8B8A
#define GL_FRAGMENT_SHADER_DERIVATIVE_HINT	0x8B8B
#define GL_FRAGMENT_SHADER_DERIVATIVE_HINT_ARB	0x8B8B
#define GL_SHADING_LANGUAGE_VERSION	0x8B8C
#define GL_SHADING_LANGUAGE_VERSION_ARB	0x8B8C
#define GL_CURRENT_PROGRAM	0x8B8D
#define GL_IMPLEMENTATION_COLOR_READ_TYPE_OES	0x8B9A
#define GL_IMPLEMENTATION_COLOR_READ_FORMAT_OES	0x8B9B
#define GL_TEXTURE_RED_TYPE_ARB	0x8C10
#define GL_TEXTURE_GREEN_TYPE_ARB	0x8C11
#define GL_TEXTURE_BLUE_TYPE_ARB	0x8C12
#define GL_TEXTURE_ALPHA_TYPE_ARB	0x8C13
#define GL_TEXTURE_LUMINANCE_TYPE_ARB	0x8C14
#define GL_TEXTURE_INTENSITY_TYPE_ARB	0x8C15
#define GL_TEXTURE_DEPTH_TYPE_ARB	0x8C16
#define GL_UNSIGNED_NORMALIZED_ARB	0x8C17
#define GL_POINT_SPRITE_COORD_ORIGIN	0x8CA0
#define GL_LOWER_LEFT	0x8CA1
#define GL_UPPER_LEFT	0x8CA2
#define GL_STENCIL_BACK_REF	0x8CA3
#define GL_STENCIL_BACK_VALUE_MASK	0x8CA4
#define GL_STENCIL_BACK_WRITEMASK	0x8CA5
#define GL_FRAMEBUFFER_BINDING_EXT	0x8CA6
#define GL_RENDERBUFFER_BINDING_EXT	0x8CA7
#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE_EXT	0x8CD0
#define GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME_EXT	0x8CD1
#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL_EXT	0x8CD2
#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE_EXT	0x8CD3
#define GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET_EXT	0x8CD4
#define GL_FRAMEBUFFER_COMPLETE_EXT	0x8CD5
#define GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT_EXT	0x8CD6
#define GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT_EXT	0x8CD7
#define GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS_EXT	0x8CD9
#define GL_FRAMEBUFFER_INCOMPLETE_FORMATS_EXT	0x8CDA
#define GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER_EXT	0x8CDB
#define GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER_EXT	0x8CDC
#define GL_FRAMEBUFFER_UNSUPPORTED_EXT	0x8CDD
#define GL_MAX_COLOR_ATTACHMENTS_EXT	0x8CDF
#define GL_COLOR_ATTACHMENT0_EXT	0x8CE0
#define GL_COLOR_ATTACHMENT1_EXT	0x8CE1
#define GL_COLOR_ATTACHMENT2_EXT	0x8CE2
#define GL_COLOR_ATTACHMENT3_EXT	0x8CE3
#define GL_COLOR_ATTACHMENT4_EXT	0x8CE4
#define GL_COLOR_ATTACHMENT5_EXT	0x8CE5
#define GL_COLOR_ATTACHMENT6_EXT	0x8CE6
#define GL_COLOR_ATTACHMENT7_EXT	0x8CE7
#define GL_COLOR_ATTACHMENT8_EXT	0x8CE8
#define GL_COLOR_ATTACHMENT9_EXT	0x8CE9
#define GL_COLOR_ATTACHMENT10_EXT	0x8CEA
#define GL_COLOR_ATTACHMENT11_EXT	0x8CEB
#define GL_COLOR_ATTACHMENT12_EXT	0x8CEC
#define GL_COLOR_ATTACHMENT13_EXT	0x8CED
#define GL_COLOR_ATTACHMENT14_EXT	0x8CEE
#define GL_COLOR_ATTACHMENT15_EXT	0x8CEF
#define GL_DEPTH_ATTACHMENT_EXT	0x8D00
#define GL_STENCIL_ATTACHMENT_EXT	0x8D20
#define GL_FRAMEBUFFER_EXT	0x8D40
#define GL_RENDERBUFFER_EXT	0x8D41
#define GL_RENDERBUFFER_WIDTH_EXT	0x8D42
#define GL_RENDERBUFFER_HEIGHT_EXT	0x8D43
#define GL_RENDERBUFFER_INTERNAL_FORMAT_EXT	0x8D44
#define GL_STENCIL_INDEX1_EXT	0x8D46
#define GL_STENCIL_INDEX4_EXT	0x8D47
#define GL_STENCIL_INDEX8_EXT	0x8D48
#define GL_STENCIL_INDEX16_EXT	0x8D49
#define GL_RENDERBUFFER_RED_SIZE_EXT	0x8D50
#define GL_RENDERBUFFER_GREEN_SIZE_EXT	0x8D51
#define GL_RENDERBUFFER_BLUE_SIZE_EXT	0x8D52
#define GL_RENDERBUFFER_ALPHA_SIZE_EXT	0x8D53
#define GL_RENDERBUFFER_DEPTH_SIZE_EXT	0x8D54
#define GL_RENDERBUFFER_STENCIL_SIZE_EXT	0x8D55
#define GL_3DFX_multisample	1
#define GL_3DFX_tbuffer	1
#define GL_3DFX_texture_compression_FXT1	1
#define GL_ARB_color_buffer_float	1
#define GL_ARB_depth_texture	1
#define GL_ARB_draw_buffers	1
#define GL_ARB_fragment_program	1
#define GL_ARB_fragment_program_shadow	1
#define GL_ARB_fragment_shader	1
#define GL_ARB_half_float_pixel	1
#define GL_ARB_matrix_palette	1
#define GL_ARB_multisample	1
#define GL_ARB_occlusion_query	1
#define GL_ARB_pixel_buffer_object	1
#define GL_ARB_point_parameters	1
#define GL_ARB_point_sprite	1
#define GL_ARB_shader_objects	1
#define GL_ARB_shading_language_100	1
#define GL_ARB_shadow	1
#define GL_ARB_shadow_ambient	1
#define GL_ARB_texture_border_clamp	1
#define GL_ARB_texture_compression	1
#define GL_ARB_texture_cube_map	1
#define GL_ARB_texture_env_add	1
#define GL_ARB_texture_env_combine	1
#define GL_ARB_texture_env_crossbar	1
#define GL_ARB_texture_env_dot3	1
#define GL_ARB_texture_float	1
#define GL_ARB_texture_mirrored_repeat	1
#define GL_ARB_texture_non_power_of_two	1
#define GL_ARB_texture_rectangle	1
#define GL_ARB_transpose_matrix	1
#define GL_ARB_vertex_blend	1
#define GL_ARB_vertex_buffer_object	1
#define GL_ARB_vertex_shader	1
#define GL_ARB_window_pos	1
#define GL_ATI_draw_buffers	1
#define GL_ATI_element_array	1
#define GL_ATI_envmap_bumpmap	1
#define GL_ATI_fragment_shader	1
#define GL_ATI_map_object_buffer	1
#define GL_ATI_pixel_format_float	1
#define GL_ATI_pn_triangles	1
#define GL_ATI_separate_stencil	1
#define GL_ATI_text_fragment_shader	1
#define GL_ATI_texture_env_combine3	1
#define GL_ATI_texture_float	1
#define GL_ATI_texture_mirror_once	1
#define GL_ATI_vertex_array_object	1
#define GL_ATI_vertex_attrib_array_object	1
#define GL_ATI_vertex_streams	1
#define GL_EXT_422_pixels	1
#define GL_EXT_abgr	1
#define GL_EXT_bgra	1
#define GL_EXT_blend_color	1
#define GL_EXT_blend_equation_separate	1
#define GL_EXT_blend_func_separate	1
#define GL_EXT_blend_logic_op	1
#define GL_EXT_blend_minmax	1
#define GL_EXT_blend_subtract	1
#define GL_EXT_clip_volume_hint	1
#define GL_EXT_cmyka	1
#define GL_EXT_color_subtable	1
#define GL_EXT_compiled_vertex_array	1
#define GL_EXT_convolution	1
#define GL_EXT_coordinate_frame	1
#define GL_EXT_copy_texture	1
#define GL_EXT_cull_vertex	1
#define GL_EXT_depth_bounds_test	1
#define GL_EXT_draw_range_elements	1
#define GL_EXT_fog_coord	1
#define GL_EXT_histogram	1
#define GL_EXT_index_array_formats	1
#define GL_EXT_index_func	1
#define GL_EXT_index_material	1
#define GL_EXT_index_texture	1
#define GL_EXT_light_texture	1
#define GL_EXT_misc_attribute	1
#define GL_EXT_multi_draw_arrays	1
#define GL_EXT_multisample	1
#define GL_EXT_packed_pixels	1
#define GL_EXT_paletted_texture	1
#define GL_EXT_pixel_buffer_object	1
#define GL_EXT_pixel_transform	1
#define GL_EXT_pixel_transform_color_table	1
#define GL_EXT_point_parameters	1
#define GL_EXT_polygon_offset	1
#define GL_EXT_rescale_normal	1
#define GL_EXT_secondary_color	1
#define GL_EXT_separate_specular_color	1
#define GL_EXT_shadow_funcs	1
#define GL_EXT_shared_texture_palette	1
#define GL_EXT_stencil_two_side	1
#define GL_EXT_stencil_wrap	1
#define GL_EXT_subtexture	1
#define GL_EXT_texture	1
#define GL_EXT_texture3D	1
#define GL_EXT_texture_env_add	1
#define GL_EXT_texture_env_combine	1
#define GL_EXT_texture_env_dot3	1
#define GL_EXT_texture_filter_anisotropic	1
#define GL_EXT_texture_lod_bias	1
#define GL_EXT_texture_mirror_clamp	1
#define GL_EXT_texture_object	1
#define GL_EXT_texture_perturb_normal	1
#define GL_EXT_vertex_array	1
#define GL_EXT_vertex_shader	1
#define GL_EXT_vertex_weighting	1
#define GL_GREMEDY_string_marker	1
#define GL_HP_convolution_border_modes	1
#define GL_HP_image_transform	1
#define GL_HP_occlusion_test	1
#define GL_HP_texture_lighting	1
#define GL_IBM_cull_vertex	1
#define GL_IBM_multimode_draw_arrays	1
#define GL_IBM_rasterpos_clip	1
#define GL_IBM_vertex_array_lists	1
#define GL_INGR_blend_func_separate	1
#define GL_INGR_color_clamp	1
#define GL_INGR_interlace_read	1
#define GL_INTEL_parallel_arrays	1
#define GL_OES_read_format	1
#define GL_PGI_misc_hints	1
#define GL_PGI_vertex_hints	1
#define GL_REND_screen_coordinates	1
#define GL_S3_s3tc	1
#define GL_SUNX_constant_data	1
#define GL_SUN_convolution_border_modes	1
#define GL_SUN_global_alpha	1
#define GL_SUN_mesh_array	1
#define GL_SUN_slice_accum	1
#define GL_SUN_triangle_list	1
#define GL_SUN_vertex	1
#define GL_WIN_phong_shading	1
#define GL_WIN_specular_fog	1
#define GL_CULL_VERTEX_IBM	103050
#define GL_VERTEX_ARRAY_LIST_IBM	103070
#define GL_NORMAL_ARRAY_LIST_IBM	103071
#define GL_COLOR_ARRAY_LIST_IBM	103072
#define GL_INDEX_ARRAY_LIST_IBM	103073
#define GL_TEXTURE_COORD_ARRAY_LIST_IBM	103074
#define GL_EDGE_FLAG_ARRAY_LIST_IBM	103075
#define GL_FOG_COORDINATE_ARRAY_LIST_IBM	103076
#define GL_SECONDARY_COLOR_ARRAY_LIST_IBM	103077
#define GL_VERTEX_ARRAY_LIST_STRIDE_IBM	103080
#define GL_NORMAL_ARRAY_LIST_STRIDE_IBM	103081
#define GL_COLOR_ARRAY_LIST_STRIDE_IBM	103082
#define GL_INDEX_ARRAY_LIST_STRIDE_IBM	103083
#define GL_TEXTURE_COORD_ARRAY_LIST_STRIDE_IBM	103084
#define GL_EDGE_FLAG_ARRAY_LIST_STRIDE_IBM	103085
#define GL_FOG_COORDINATE_ARRAY_LIST_STRIDE_IBM	103086
#define GL_SECONDARY_COLOR_ARRAY_LIST_STRIDE_IBM	103087
#define GL_MODELVIEW0_EXT	GL_MODELVIEW
#define GL_MODELVIEW0_MATRIX_EXT	GL_MODELVIEW_MATRIX
#define GL_MODELVIEW0_STACK_DEPTH_EXT	GL_MODELVIEW_STACK_DEPTH
#endif				/* __LSB_VERSION__ >= 1.2 */



    typedef unsigned int GLhandleARB;

    typedef ptrdiff_t GLintptr;

    typedef char GLchar;

    typedef char GLcharARB;

    typedef ptrdiff_t GLsizeiptr;

    typedef ptrdiff_t GLsizeiptrARB;

    typedef long int GLintptrARB;

#ifdef __cplusplus
}
#endif
#endif				/* protection */
#endif				/* LSB version */
