#if (__LSB_VERSION__ >= 10 )
#ifndef _GL_GLX_H_
#define _GL_GLX_H_

#include <X11/Xlib.h>
#include <X11/X.h>
#include <X11/Xutil.h>

#ifdef __cplusplus
extern "C" {
#endif


#define GLX_EXTENSION_NAME	"GLX"
#define GLX_FRONT_LEFT_BUFFER_BIT	0x00000001
#define GLX_RGBA_BIT	0x00000001
#define GLX_WINDOW_BIT	0x00000001
#define GLX_COLOR_INDEX_BIT	0x00000002
#define GLX_FRONT_RIGHT_BUFFER_BIT	0x00000002
#define GLX_PIXMAP_BIT	0x00000002
#define GLX_BACK_LEFT_BUFFER_BIT	0x00000004
#define GLX_PBUFFER_BIT	0x00000004
#define GLX_BACK_RIGHT_BUFFER_BIT	0x00000008
#define GLX_AUX_BUFFERS_BIT	0x00000010
#define GLX_DEPTH_BUFFER_BIT	0x00000020
#define GLX_STENCIL_BUFFER_BIT	0x00000040
#define GLX_ACCUM_BUFFER_BIT	0x00000080
#define GLX_PBUFFER_CLOBBER_MASK	0x08000000
#define GLX_SAMPLE_BUFFERS	0x186a0
#define GLX_SAMPLES	0x186a1
#define GLX_CONFIG_CAVEAT	0x20
#define GLX_X_VISUAL_TYPE	0x22
#define GLX_TRANSPARENT_TYPE	0x23
#define GLX_TRANSPARENT_INDEX_VALUE	0x24
#define GLX_TRANSPARENT_RED_VALUE	0x25
#define GLX_TRANSPARENT_GREEN_VALUE	0x26
#define GLX_TRANSPARENT_BLUE_VALUE	0x27
#define GLX_TRANSPARENT_ALPHA_VALUE	0x28
#define GLX_NONE	0x8000
#define GLX_SLOW_CONFIG	0x8001
#define GLX_TRUE_COLOR	0x8002
#define GLX_DIRECT_COLOR	0x8003
#define GLX_PSEUDO_COLOR	0x8004
#define GLX_STATIC_COLOR	0x8005
#define GLX_GRAY_SCALE	0x8006
#define GLX_STATIC_GRAY	0x8007
#define GLX_TRANSPARENT_RGB	0x8008
#define GLX_TRANSPARENT_INDEX	0x8009
#define GLX_VISUAL_ID	0x800B
#define GLX_SCREEN	0x800C
#define GLX_NON_CONFORMANT_CONFIG	0x800D
#define GLX_DRAWABLE_TYPE	0x8010
#define GLX_RENDER_TYPE	0x8011
#define GLX_X_RENDERABLE	0x8012
#define GLX_FBCONFIG_ID	0x8013
#define GLX_RGBA_TYPE	0x8014
#define GLX_COLOR_INDEX_TYPE	0x8015
#define GLX_MAX_PBUFFER_WIDTH	0x8016
#define GLX_MAX_PBUFFER_HEIGHT	0x8017
#define GLX_MAX_PBUFFER_PIXELS	0x8018
#define GLX_PRESERVED_CONTENTS	0x801B
#define GLX_LARGEST_PBUFFER	0x801C
#define GLX_WIDTH	0x801D
#define GLX_HEIGHT	0x801E
#define GLX_EVENT_MASK	0x801F
#define GLX_DAMAGED	0x8020
#define GLX_SAVED	0x8021
#define GLX_WINDOW	0x8022
#define GLX_PBUFFER	0x8023
#define GLX_PBUFFER_HEIGHT	0x8040
#define GLX_PBUFFER_WIDTH	0x8041
#define GLX_DONT_CARE	0xFFFFFFFF
#define GLX_ARB_render_texture	1
#define GLX_BAD_SCREEN	1
#define GLX_EXT_texture_from_pixmap	1
#define GLX_USE_GL	1
#define GLX_VENDOR	1
#define GLX_VERSION_1_1	1
#define GLX_VERSION_1_2	1
#define GLX_VERSION_1_3	1
#define GLX_VERSION_1_4	1
#define GLX_BLUE_SIZE	10
#define GLX_ALPHA_SIZE	11
#define GLX_DEPTH_SIZE	12
#define GLX_STENCIL_SIZE	13
#define GLX_ACCUM_RED_SIZE	14
#define GLX_ACCUM_GREEN_SIZE	15
#define GLX_ACCUM_BLUE_SIZE	16
#define GLX_ACCUM_ALPHA_SIZE	17
#define GLX_BAD_ATTRIBUTE	2
#define GLX_BUFFER_SIZE	2
#define GLX_VERSION	2
#define GLX_EXTENSIONS	3
#define GLX_LEVEL	3
#define GLX_NO_EXTENSION	3
#define GLX_BAD_VISUAL	4
#define GLX_RGBA	4
#define GLX_BAD_CONTEXT	5
#define GLX_DOUBLEBUFFER	5
#define GLX_BAD_VALUE	6
#define GLX_STEREO	6
#define GLX_AUX_BUFFERS	7
#define GLX_BAD_ENUM	7
#define GLX_RED_SIZE	8
#define GLX_GREEN_SIZE	9
#if __LSB_VERSION__ >= 13
#define GLX_ARB_get_proc_address	1
#define GLX_GLXEXT_VERSION	6
#endif				/* __LSB_VERSION__ >= 1.3 */



    typedef struct __GLXcontextRec *GLXContext;

    typedef XID GLXDrawable;

    typedef union __GLXEvent GLXEvent;

    typedef XID GLXContextID;

    typedef XID GLXPixmap;

    typedef struct {
	int event_type;
	int draw_type;
	unsigned long int serial;
	int send_event;
	Display *display;
	GLXDrawable drawable;
	unsigned int buffer_mask;
	unsigned int aux_buffer;
	int x;
	int y;
	int width;
	int height;
	int count;
    } GLXPbufferClobberEvent;

    typedef XID GLXPbuffer;

    typedef XID GLXWindow;

    typedef XID GLXFBConfigID;

    typedef void (*__GLXextFuncPtr) (void);

#include <GL/glxext.h>
#if __LSB_VERSION__ >= 12
    typedef struct __GLXFBConfigRec *GLXFBConfig;

#endif				/* __LSB_VERSION__ >= 1.2 */

    union __GLXEvent {
	GLXPbufferClobberEvent glxpbufferclobber;
	long int pad;
    };


/* Function prototypes */

    extern GLXFBConfig *glXChooseFBConfig(Display * dpy, int screen,
					  const int *attribList,
					  int *nitems);
    extern XVisualInfo *glXChooseVisual(Display * dpy, int screen,
					int *attribList);
    extern void glXCopyContext(Display * dpy, struct __GLXcontextRec *src,
			       struct __GLXcontextRec *dst,
			       long unsigned int mask);
    extern GLXContext glXCreateContext(Display * dpy, XVisualInfo * vis,
				       struct __GLXcontextRec *shareList,
				       int direct);
    extern GLXPixmap glXCreateGLXPixmap(Display * dpy, XVisualInfo * vis,
					Pixmap pixmap);
    extern GLXContext glXCreateNewContext(Display * dpy,
					  struct __GLXFBConfigRec *config,
					  int renderType,
					  struct __GLXcontextRec
					  *shareList, int direct);
    extern GLXPbuffer glXCreatePbuffer(Display * dpy,
				       struct __GLXFBConfigRec *config,
				       const int *attribList);
    extern GLXPixmap glXCreatePixmap(Display * dpy,
				     struct __GLXFBConfigRec *config,
				     Pixmap pixmap, const int *attribList);
    extern GLXWindow glXCreateWindow(Display * dpy,
				     struct __GLXFBConfigRec *config,
				     Window win, const int *attribList);
    extern void glXDestroyContext(Display * dpy,
				  struct __GLXcontextRec *ctx);
    extern void glXDestroyGLXPixmap(Display * dpy, GLXPixmap pix);
    extern void glXDestroyPbuffer(Display * dpy, GLXPbuffer pbuf);
    extern void glXDestroyPixmap(Display * dpy, GLXPixmap pixmap);
    extern void glXDestroyWindow(Display * dpy, GLXWindow window);
    extern const char *glXGetClientString(Display * dpy, int name);
    extern int glXGetConfig(Display * dpy, XVisualInfo * vis, int attrib,
			    int *value);
    extern GLXContext glXGetCurrentContext(void);
    extern Display *glXGetCurrentDisplay(void);
    extern GLXDrawable glXGetCurrentDrawable(void);
    extern GLXDrawable glXGetCurrentReadDrawable(void);
    extern int glXGetFBConfigAttrib(Display * dpy, GLXFBConfig config,
				    int attribute, int *value);
    extern void glXGetSelectedEvent(Display * dpy, GLXDrawable drawable,
				    unsigned long int *mask);
    extern XVisualInfo *glXGetVisualFromFBConfig(Display * dpy,
						 GLXFBConfig config);
    extern int glXIsDirect(Display * dpy, struct __GLXcontextRec *ctx);
    extern int glXMakeContextCurrent(Display * dpy, GLXDrawable draw,
				     GLXDrawable read, GLXContext ctx);
    extern int glXMakeCurrent(Display * dpy, GLXDrawable drawable,
			      struct __GLXcontextRec *ctx);
    extern int glXQueryContext(Display * dpy, GLXContext ctx,
			       int attribute, int *value);
    extern void glXQueryDrawable(Display * dpy, GLXDrawable draw,
				 int attribute, unsigned int *value);
    extern int glXQueryExtension(Display * dpy, int *errorBase,
				 int *eventBase);
    extern const char *glXQueryExtensionsString(Display * dpy, int screen);
    extern const char *glXQueryServerString(Display * dpy, int screen,
					    int name);
    extern int glXQueryVersion(Display * dpy, int *major, int *minor);
    extern void glXSelectEvent(Display * dpy, GLXDrawable drawable,
			       long unsigned int mask);
    extern void glXSwapBuffers(Display * dpy, GLXDrawable drawable);
    extern void glXUseXFont(Font font, int first, int count, int listBase);
    extern void glXWaitGL(void);
    extern void glXWaitX(void);
#if __LSB_VERSION__ >= 32
    extern GLXFBConfig *glXGetFBConfigs(Display * dpy, int screen,
					int *nelements);
#endif				/* __LSB_VERSION__ >= 3.2 */

#ifdef __cplusplus
}
#endif
#endif				/* protection */
#endif				/* LSB version */
